Package: finetune
Title: Additional Functions for Model Tuning
Version: 1.3.0
Authors@R: c(
    person("Max", "Kuhn", , "max@posit.co", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0003-2402-136X")),
    person("Posit Software, PBC", role = c("cph", "fnd"),
           comment = c(ROR = "03wc8by49"))
  )
Description: The ability to tune models is important. 'finetune' enhances
    the 'tune' package by providing more specialized methods for finding
    reasonable values of model tuning parameters.  Two racing methods
    described by Kuhn (2014) <doi:10.48550/arXiv.1405.6974> are included.
    An iterative search method using generalized simulated annealing
    (Bohachevsky, Johnson and Stein, 1986)
    <doi:10.1080/00401706.1986.10488128> is also included.
License: MIT + file LICENSE
URL: https://github.com/tidymodels/finetune,
        https://finetune.tidymodels.org
BugReports: https://github.com/tidymodels/finetune/issues
Depends: R (>= 4.1), tune (>= 2.1.0)
Imports: cli, dials (>= 0.3.0), dplyr (>= 1.1.1), ggplot2, parsnip (>=
        1.1.0), purrr (>= 1.0.0), rlang (>= 1.1.0), tibble, tidyr,
        tidyselect, utils, vctrs, workflows (>= 0.2.6)
Suggests: BradleyTerry2, covr, discrim, kknn, klaR, lme4, modeldata,
        ranger, recipes (>= 0.2.0), rpart, rsample, spelling, testthat,
        yardstick
Config/Needs/website: tidyverse/tidytemplate
Config/testthat/edition: 3
Config/usethis/last-upkeep: 2025-05-20
Encoding: UTF-8
Language: en-US
RoxygenNote: 7.3.3
NeedsCompilation: no
Packaged: 2026-04-17 20:09:33 UTC; max
Author: Max Kuhn [aut, cre] (ORCID: <https://orcid.org/0000-0003-2402-136X>),
  Posit Software, PBC [cph, fnd] (ROR: <https://ror.org/03wc8by49>)
Maintainer: Max Kuhn <max@posit.co>
Repository: CRAN
Date/Publication: 2026-04-18 17:00:02 UTC

<img src="https://i.imgur.com/kYL058E.png" width="100%">

**Scikit-learn style model finetuning for NLP**

Finetune is a library that allows users to leverage state-of-the-art pretrained NLP models for a wide variety of downstream tasks.

Finetune currently supports TensorFlow implementations of the following models:

1. **BERT**, from ["BERT: Pre-training of Deep Bidirectional Transformers for Language Understanding"](https://arxiv.org/abs/1810.04805)
2. **RoBERTa**, from ["RoBERTa: A Robustly Optimized BERT Pretraining Approach"](https://arxiv.org/abs/1907.11692)
3. **GPT**, from ["Improving Language Understanding by Generative Pre-Training"](https://s3-us-west-2.amazonaws.com/openai-assets/research-covers/language-unsupervised/language_understanding_paper.pdf)
4. **GPT2**, from ["Language Models are Unsupervised Multitask Learners"](https://d4mucfpksywv.cloudfront.net/better-language-models/language-models.pdf)
5. **TextCNN**, from ["Convolutional Neural Networks for Sentence Classification"](https://arxiv.org/abs/1408.5882)
6. **Temporal Convolution Network**, from ["An Empirical Evaluation of Generic Convolutional and Recurrent Networks for Sequence Modeling"](https://arxiv.org/pdf/1803.01271.pdf)
7. **DistilBERT** from ["Smaller, faster, cheaper, lighter: Introducing DistilBERT, a distilled version of BERT"](https://medium.com/huggingface/distilbert-8cf3380435b5)


| Section | Description |
|-|-|
| [API Tour](#finetune-api-tour) | Base models, configurables, and more |
| [Installation](#installation-tour) | How to install using pip or directly from source |
| [Finetune with Docker](#docker) | Finetune and inference within a Docker Container |
| [Documentation](https://finetune.indico.io/) | Full API documentation |

# Finetune API Tour

Finetuning the base language model is as easy as calling `Classifier.fit`:

```python3
model = Classifier()               # Load base model
model.fit(trainX, trainY)          # Finetune base model on custom data
model.save(path)                   # Serialize the model to disk
...
model = Classifier.load(path)      # Reload models from disk at any time
predictions = model.predict(testX) # [{'class_1': 0.23, 'class_2': 0.54, ..}, ..]
```

Choose your desired base model from `finetune.base_models`:
```python3
from finetune.base_models import BERT, RoBERTa, GPT, GPT2, TextCNN, TCN
model = Classifier(base_model=BERT)
```

Optimize your model with a variety of configurables. A detailed list of all config items can be found [in the finetune docs](https://finetune.indico.io/config.html).
```python3
model = Classifier(low_memory_mode=True, lr_schedule="warmup_linear", max_length=512, l2_reg=0.01, oversample=True, ...)
```

The library supports finetuning for a number of tasks. A detailed description of all target models can be found [in the finetune API reference](https://finetune.indico.io/api.html).
```python3
from finetune import *
models = (Classifier, MultiLabelClassifier, MultiFieldClassifier, MultipleChoice, # Classify one or more inputs into one or more classes
          Regressor, OrdinalRegressor, MultifieldRegressor,                       # Regress on one or more inputs
          SequenceLabeler, Association,                                           # Extract tokens from a given class, or infer relationships between them
          Comparison, ComparisonRegressor, ComparisonOrdinalRegressor,            # Compare two documents for a given task
          LanguageModel, MultiTask,                                               # Further pretrain your base models
          DeploymentModel                                                         # Wrapper to optimize your serialized models for a production environment
          )
```
For example usage of each of these target types, see the [finetune/datasets directory](https://github.com/IndicoDataSolutions/finetune/tree/master/finetune/datasets).
For purposes of simplicity and runtime these examples use smaller versions of the published datasets.






If you have large amounts of unlabeled training data and only a small amount of labeled training data,
you can finetune in two steps for best performance.

```python3
model = Classifier()               # Load base model
model.fit(unlabeledX)              # Finetune base model on unlabeled training data
model.fit(trainX, trainY)          # Continue finetuning with a smaller amount of labeled data
predictions = model.predict(testX) # [{'class_1': 0.23, 'class_2': 0.54, ..}, ..]
model.save(path)                   # Serialize the model to disk
```

# Installation

Finetune can be installed directly from PyPI by using `pip`

```
pip3 install finetune
```

or installed directly from source:

```bash
git clone -b master https://github.com/IndicoDataSolutions/finetune && cd finetune
python3 setup.py develop              # symlinks the git directory to your python path
pip3 install tensorflow-gpu --upgrade # or tensorflow-cpu
python3 -m spacy download en          # download spacy tokenizer
```

In order to run `finetune` on your host, you'll need a working copy of tensorflow-gpu >= 1.14.0 and up to date nvidia-driver versions.

You can optionally run the provided test suite to ensure installation completed successfully.

```bash
pip3 install pytest
pytest
```


# Docker

If you'd prefer you can also run `finetune` in a docker container. The bash scripts provided assume you have a functional install of [docker](https://docs.docker.com/install/) and [nvidia-docker](https://github.com/nvidia/nvidia-docker/wiki/Installation-(version-2.0)).

```
git clone https://github.com/IndicoDataSolutions/finetune && cd finetune

# For usage with NVIDIA GPUs
./docker/build_gpu_docker.sh      # builds a docker image
./docker/start_gpu_docker.sh      # starts a docker container in the background, forwards $PWD to /finetune

docker exec -it finetune bash # starts a bash session in the docker container
```

For CPU-only usage:
```
./docker/build_cpu_docker.sh
./docker/start_cpu_docker.sh
```

# Documentation
Full documentation and an API Reference for `finetune` is available at [finetune.indico.io](https://finetune.indico.io).

<!-- README.md is generated from README.Rmd. Please edit that file -->

# finetune <a href='https://finetune.tidymodels.org'><img src='man/figures/logo.png' align="right" height="138" /></a>

<!-- badges: start -->

[![R-CMD-check](https://github.com/tidymodels/finetune/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/tidymodels/finetune/actions/workflows/R-CMD-check.yaml)
[![Codecov test
coverage](https://codecov.io/gh/tidymodels/finetune/branch/main/graph/badge.svg)](https://app.codecov.io/gh/tidymodels/finetune?branch=main)
[![Lifecycle](https://img.shields.io/badge/lifecycle-experimental-orange.svg)](https://lifecycle.r-lib.org/articles/stages.html)
[![Codecov test
coverage](https://codecov.io/gh/tidymodels/finetune/graph/badge.svg)](https://app.codecov.io/gh/tidymodels/finetune)
<!-- badges: end -->

`finetune` contains some extra functions for model tuning that extend
what is currently in the `tune` package. You can install the CRAN
version of the package with the following code:

``` r
install.packages("finetune")
```

To install the development version of the package, run:

``` r
# install.packages("pak")
pak::pak("tidymodels/finetune")
```

There are two main sets of tools in the package: *simulated annealing*
and *racing*.

Tuning via *simulated annealing* optimization is an iterative search
tool for finding good values:

``` r
library(tidymodels)
library(finetune)

# Syntax very similar to `tune_grid()` or `tune_bayes()`: 

## -----------------------------------------------------------------------------

data(two_class_dat, package = "modeldata")

set.seed(1)
rs <- bootstraps(two_class_dat, times = 10) # more resamples usually needed

# Optimize a regularized discriminant analysis model
library(discrim)
rda_spec <-
  discrim_regularized(frac_common_cov = tune(), frac_identity = tune()) |>
  set_engine("klaR")

## -----------------------------------------------------------------------------

set.seed(2)
sa_res <- 
  rda_spec |> 
  tune_sim_anneal(Class ~ ., resamples = rs, iter = 20, initial = 4)
#> Optimizing roc_auc
#> Initial best: 0.88281
#> 1 ◯ accept suboptimal  roc_auc=0.87797 (+/-0.004187)
#> 2 + better suboptimal  roc_auc=0.87811 (+/-0.004082)
#> 3 ◯ accept suboptimal  roc_auc=0.86938 (+/-0.005172)
#> 4 ◯ accept suboptimal  roc_auc=0.85949 (+/-0.006067)
#> 5 ◯ accept suboptimal  roc_auc=0.84727 (+/-0.006757)
#> 6 ◯ accept suboptimal  roc_auc=0.84441 (+/-0.006885)
#> 7 + better suboptimal  roc_auc=0.84715 (+/-0.006718)
#> 8 ✖ restart from best  roc_auc=0.85368 (+/-0.006366)
#> 9 ◯ accept suboptimal  roc_auc=0.88032 (+/-0.00397)
#> 10 ◯ accept suboptimal  roc_auc=0.87373 (+/-0.004807)
#> 11 + better suboptimal  roc_auc=0.87691 (+/-0.004533)
#> 12 ◯ accept suboptimal  roc_auc=0.86149 (+/-0.005802)
#> 13 + better suboptimal  roc_auc=0.86304 (+/-0.005684)
#> 14 + better suboptimal  roc_auc=0.87479 (+/-0.004721)
#> 15 ◯ accept suboptimal  roc_auc=0.86637 (+/-0.005425)
#> 16 ✖ restart from best  roc_auc=0.85841 (+/-0.006111)
#> 17 ◯ accept suboptimal  roc_auc=0.87862 (+/-0.004139)
#> 18 + better suboptimal  roc_auc=0.88011 (+/-0.004023)
#> 19 ◯ accept suboptimal  roc_auc=0.87175 (+/-0.004952)
#> 20 ─ discard suboptimal roc_auc=0.86236 (+/-0.005762)
show_best(sa_res, metric = "roc_auc", n = 2)
#> # A tibble: 2 × 9
#>   frac_common_cov frac_identity .metric .estimator  mean     n std_err .config  
#>             <dbl>         <dbl> <chr>   <chr>      <dbl> <int>   <dbl> <chr>    
#> 1           0.667        0      roc_auc binary     0.883    10 0.00360 initial_…
#> 2           0.793        0.0344 roc_auc binary     0.880    10 0.00397 Iter9    
#> # ℹ 1 more variable: .iter <int>
```

The second set of methods are for *racing*. We start off by doing a
small set of resamples for all of the grid points, then statistically
testing to see which ones should be dropped or investigated more. The
two methods here are based on those should in [Kuhn
(2014)](https://arxiv.org/abs/1405.6974).

For example, using an ANOVA-type analysis to filter out parameter
combinations:

``` r
set.seed(3)
grid <-
  rda_spec |>
  extract_parameter_set_dials() |>
  grid_max_entropy(size = 20)
#> Warning: `grid_max_entropy()` was deprecated in dials 1.3.0.
#> ℹ Please use `grid_space_filling()` instead.
#> This warning is displayed once every 8 hours.
#> Call `lifecycle::last_lifecycle_warnings()` to see where this warning was
#> generated.

ctrl <- control_race(verbose_elim = TRUE)

set.seed(4)
grid_anova <- 
  rda_spec |> 
  tune_race_anova(Class ~ ., resamples = rs, grid = grid, control = ctrl)
#> ℹ Evaluating against the initial 3 burn-in resamples.
#> ℹ Racing will maximize the roc_auc metric.
#> ℹ Resamples are analyzed in a random order.
#> ℹ Bootstrap10: 14 eliminated; 6 candidates remain.
#> 
#> ℹ Bootstrap04: 2 eliminated; 4 candidates remain.
#> 
#> ℹ Bootstrap03: All but one parameter combination were eliminated.

show_best(grid_anova, metric = "roc_auc", n = 2)
#> # A tibble: 1 × 8
#>   frac_common_cov frac_identity .metric .estimator  mean     n std_err .config  
#>             <dbl>         <dbl> <chr>   <chr>      <dbl> <int>   <dbl> <chr>    
#> 1           0.831        0.0207 roc_auc binary     0.881    10 0.00386 Preproce…
```

`tune_race_win_loss()` can also be used. It treats the tuning parameters
as sports teams in a tournament and computed win/loss statistics.

``` r
set.seed(4)
grid_win_loss<- 
  rda_spec |> 
  tune_race_win_loss(Class ~ ., resamples = rs, grid = grid, control = ctrl)
#> ℹ Racing will maximize the roc_auc metric.
#> ℹ Resamples are analyzed in a random order.
#> ℹ Bootstrap10: 3 eliminated; 17 candidates remain.
#> 
#> ℹ Bootstrap04: 2 eliminated; 15 candidates remain.
#> 
#> ℹ Bootstrap03: 2 eliminated; 13 candidates remain.
#> 
#> ℹ Bootstrap01: 1 eliminated; 12 candidates remain.
#> 
#> ℹ Bootstrap07: 1 eliminated; 11 candidates remain.
#> 
#> ℹ Bootstrap05: 1 eliminated; 10 candidates remain.
#> 
#> ℹ Bootstrap08: 1 eliminated; 9 candidates remain.

show_best(grid_win_loss, metric = "roc_auc", n = 2)
#> # A tibble: 2 × 8
#>   frac_common_cov frac_identity .metric .estimator  mean     n std_err .config  
#>             <dbl>         <dbl> <chr>   <chr>      <dbl> <int>   <dbl> <chr>    
#> 1           0.831        0.0207 roc_auc binary     0.881    10 0.00386 Preproce…
#> 2           0.119        0.0470 roc_auc binary     0.879    10 0.00387 Preproce…
```

## Contributing

This project is released with a [Contributor Code of
Conduct](https://contributor-covenant.org/version/2/0/CODE_OF_CONDUCT.html).
By contributing to this project, you agree to abide by its terms.

- For questions and discussions about tidymodels packages, modeling, and
  machine learning, please [post on Posit
  Community](https://forum.posit.co/new-topic?category_id=15&tags=tidymodels,question).

- If you think you have encountered a bug, please [submit an
  issue](https://github.com/tidymodels/usemodels/issues).

- Either way, learn how to create and share a
  [reprex](https://reprex.tidyverse.org/articles/articles/learn-reprex.html)
  (a minimal, reproducible example), to clearly communicate about your
  code.

- Check out further details on [contributing guidelines for tidymodels
  packages](https://www.tidymodels.org/contribute/) and [how to get
  help](https://www.tidymodels.org/help/).

.onLoad <- function(libname, pkgname) {
  vctrs::s3_register("tune::show_best", "tune_race")
  vctrs::s3_register("tune::collect_metrics", "tune_race")
  vctrs::s3_register("tune::collect_predictions", "tune_race")
}

#' Control aspects of the simulated annealing search process
#' @inheritParams tune::control_grid
#' @param verbose_iter A logical for logging results of the search
#'   process. Defaults to FALSE. If using a dark IDE theme, some logging
#'   messages might be hard to see; try setting the `tidymodels.dark` option
#'   with `options(tidymodels.dark = TRUE)` to print lighter colors.
#' @param no_improve The integer cutoff for the number of iterations without
#'   better results.
#' @param restart The number of iterations with no improvement before new tuning
#' parameter candidates are generated from the last, overall best conditions.
#' @param radius Two real numbers on `(0, 1)` describing what a value "in the
#' neighborhood" of the current result should be. If all numeric parameters were
#' scaled to be on the `[0, 1]` scale, these values set the min. and max.
#' of a radius of a circle used to generate new numeric parameter values.
#' @param flip A real number between `[0, 1]` for the probability of changing
#' any non-numeric parameter values at each iteration.
#' @param cooling_coef A real, positive number to influence the cooling
#' schedule. Larger values decrease the probability of accepting a sub-optimal
#' parameter setting.
#' @param time_limit A number for the minimum number of _minutes_ (elapsed) that
#'   the function should execute. The elapsed time is evaluated at internal
#'   checkpoints and, if over time, the results at that time are returned (with
#'   a warning). This means that the `time_limit` is not an exact limit, but a
#'   minimum time limit.
#' @param save_history A logical to save the iteration details of the search.
#'  These are saved to `tempdir()` named `sa_history.RData`. These results are
#'  deleted when the R session ends. This option is only useful for teaching
#'  purposes.
#' @return An object of class `control_sim_anneal` that echos the argument values.
#' @examples
#' control_sim_anneal()
#' @export
control_sim_anneal <-
  function(
    verbose = FALSE,
    verbose_iter = TRUE,
    no_improve = Inf,
    restart = 8L,
    radius = c(0.05, 0.15),
    flip = 3 / 4,
    cooling_coef = 0.02,
    extract = NULL,
    save_pred = FALSE,
    time_limit = NA,
    pkgs = NULL,
    save_workflow = FALSE,
    save_history = FALSE,
    event_level = "first",
    parallel_over = NULL,
    allow_par = TRUE,
    backend_options = NULL,
    workflow_size = 100
  ) {
    # Any added arguments should also be added in superset control functions
    # in other package. In other words, if tune_grid adds an option, the same
    # object should be added here (regardless)

    check_bool(verbose)
    check_bool(verbose_iter)
    check_bool(save_pred)
    check_number_whole(no_improve, min = 2, allow_infinite = TRUE)
    check_number_whole(restart, min = 2)
    check_number_decimal(flip)
    check_number_decimal(cooling_coef)
    check_function(extract, allow_null = TRUE)
    check_number_decimal(time_limit, allow_na = TRUE)
    check_character(pkgs, allow_null = TRUE)
    check_bool(save_workflow)
    check_bool(save_history)
    check_bool(allow_par)

    if (!is.null(parallel_over)) {
      rlang::arg_match0(parallel_over, c("resamples", "everything"))
    }

    if (!is.numeric(radius) | !length(radius) == 2) {
      cli::cli_abort("Argument {.arg radius} should be two numeric values.")
    }
    radius <- sort(radius)
    radius[radius <= 0] <- 0.001
    radius[radius >= 1] <- 0.999

    flip[flip < 0] <- 0
    flip[flip > 1] <- 1
    cooling_coef[cooling_coef <= 0] <- 0.0001

    if (!is.infinite(restart) && restart > no_improve) {
      cli::cli_alert_warning(
        "Parameter restart is scheduled after {restart} poor iterations but the search will stop after {no_improve}."
      )
    }

    res <-
      list(
        verbose = verbose,
        verbose_iter = verbose_iter,
        no_improve = no_improve,
        restart = restart,
        radius = radius,
        flip = flip,
        cooling_coef = cooling_coef,
        extract = extract,
        save_pred = save_pred,
        time_limit = time_limit,
        pkgs = pkgs,
        save_workflow = save_workflow,
        save_history = save_history,
        event_level = event_level,
        parallel_over = parallel_over,
        allow_par = allow_par,
        backend_options = backend_options,
        workflow_size = workflow_size
      )

    class(res) <- "control_sim_anneal"
    res
  }

#' @export
print.control_sim_anneal <- function(x, ...) {
  cat("Simulated annealing control object\n")
  invisible(x)
}

## -----------------------------------------------------------------------------

test_that("control_sim_anneal arg passing", {
  expect_equal(control_sim_anneal(verbose = TRUE)$verbose, TRUE)
  expect_equal(control_sim_anneal(no_improve = 13)$no_improve, 13L)
  expect_equal(control_sim_anneal(restart = 2)$restart, 2)
  expect_equal(control_sim_anneal(radius = rep(.12, 2))$radius, rep(.12, 2))
  expect_equal(control_sim_anneal(flip = .122)$flip, .122)
  expect_equal(control_sim_anneal(cooling_coef = 1 / 10)$cooling_coef, 1 / 10)
  expect_equal(
    control_sim_anneal(extract = function(x) x)$extract,
    function(x) x
  )
  expect_equal(control_sim_anneal(save_pred = TRUE)$save_pred, TRUE)
  expect_equal(control_sim_anneal(time_limit = 2)$time_limit, 2)
  expect_equal(control_sim_anneal(pkgs = "carrot")$pkgs, "carrot")
  expect_equal(control_sim_anneal(save_workflow = TRUE)$save_workflow, TRUE)
})

test_that("control_sim_anneal bad arg passing", {
  expect_snapshot(error = TRUE, control_sim_anneal(verbose = "TRUE"))
  expect_snapshot(error = TRUE, control_sim_anneal(verbose = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_sim_anneal(verbose_iter = "TRUE"))
  expect_snapshot(error = TRUE, control_sim_anneal(save_pred = "TRUE"))
  expect_snapshot(error = TRUE, control_sim_anneal(save_pred = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_sim_anneal(save_workflow = "TRUE"))
  expect_snapshot(
    error = TRUE,
    control_sim_anneal(save_workflow = rep(TRUE, 2))
  )
  expect_snapshot(error = TRUE, control_sim_anneal(save_history = "TRUE"))
  expect_snapshot(error = TRUE, control_sim_anneal(allow_par = "TRUE"))
  expect_snapshot(error = TRUE, control_sim_anneal(no_improve = "yes"))
  expect_snapshot(error = TRUE, control_sim_anneal(no_improve = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(no_improve = 1))
  expect_snapshot(error = TRUE, control_sim_anneal(restart = "yes"))
  expect_snapshot(error = TRUE, control_sim_anneal(restart = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(restart = 1))
  expect_snapshot(control_sim_anneal(no_improve = 2, restart = 6))
  expect_snapshot(error = TRUE, control_sim_anneal(radius = "huge"))
  expect_equal(control_sim_anneal(radius = c(-1, .2))$radius, c(0.001, .2))
  expect_equal(control_sim_anneal(radius = c(15, .1))$radius, c(.1, 0.999))
  expect_snapshot(error = TRUE, control_sim_anneal(flip = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(flip = "huge"))
  expect_equal(control_sim_anneal(flip = -1)$flip, 0)
  expect_equal(control_sim_anneal(flip = 2)$flip, 1)
  expect_snapshot(error = TRUE, control_sim_anneal(cooling_coef = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(cooling_coef = "huge"))
  expect_equal(control_sim_anneal(cooling_coef = -1)$cooling_coef, 0.0001)
  expect_equal(control_sim_anneal(cooling_coef = 2)$cooling_coef, 2)
  expect_snapshot(error = TRUE, control_sim_anneal(time_limit = "soon"))
  expect_snapshot(error = TRUE, control_sim_anneal(pkg = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(extract = 0:1))
  expect_snapshot(error = TRUE, control_sim_anneal(parallel_over = "other"))
})

test_that("casting control_sim_anneal to control_grid", {
  expect_snapshot(parsnip::condense_control(
    control_sim_anneal(),
    control_grid()
  ))
})

test_that("control_race works with condense_control", {
  expect_equal(
    parsnip::condense_control(control_race(), control_grid()),
    control_grid(parallel_over = "everything")
  )

  expect_equal(
    parsnip::condense_control(control_race(), control_resamples()),
    control_resamples(parallel_over = "everything")
  )
})

test_that("control_sim_anneal works with condense_control", {
  expect_equal(
    parsnip::condense_control(control_sim_anneal(), control_grid()),
    control_grid(verbose = FALSE)
  )

  expect_equal(
    parsnip::condense_control(control_sim_anneal(), control_resamples()),
    control_resamples(verbose = FALSE)
  )
})

skip_if_not_installed("tune", minimum_version = "1.3.0.9006")

test_that("formula interface", {
  skip_on_cran()

  expect_message(
    {
      set.seed(1)
      res <- f_wflow |>
        tune_sim_anneal(
          cell_folds,
          iter = 2,
          control = control_sim_anneal(verbose = TRUE)
        )
    },
    regex = "Fold1"
  )

  expect_equal(
    class(res),
    c("iteration_results", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) == 9)
  expect_equal(res, .Last.tune.result)
  expect_null(.get_tune_eval_times(res))
  expect_null(.get_tune_eval_time_target(res))
})

# ------------------------------------------------------------------------------

test_that("recipe interface", {
  skip_on_cran()

  expect_silent(
    {
      set.seed(1)
      res <- rec_wflow |>
        tune_sim_anneal(
          cell_folds,
          iter = 2,
          control = control_sim_anneal(verbose = FALSE, verbose_iter = FALSE)
        )
    }
  )

  expect_equal(
    class(res),
    c("iteration_results", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) == 9)
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("variable interface", {
  skip_on_cran()
  expect_message(
    {
      set.seed(1)
      res <- var_wflow |>
        tune_sim_anneal(
          cell_folds,
          iter = 2,
          control = control_sim_anneal(verbose = TRUE, verbose_iter = TRUE)
        )
    },
    regex = "Fold3"
  )
  expect_equal(
    class(res),
    c("iteration_results", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) == 9)
  expect_equal(res, .Last.tune.result)

  # Check to see if iterations are picked up when an iterative object is used
  # as the initial object

  expect_message(
    {
      set.seed(1)
      new_res <- var_wflow |>
        tune_sim_anneal(
          cell_folds,
          iter = 2,
          initial = res,
          control = control_sim_anneal(verbose = FALSE)
        )
    },
    regex = "previous iterations"
  )

  expect_true(nrow(collect_metrics(new_res)) == 15)
  expect_true(max(new_res$.iter) == 4)
  expect_true(sum(grepl("^initial", collect_metrics(new_res)$.config)) == 9)
  expect_equal(new_res, .Last.tune.result)

  # but not for non-iterative objects
  set.seed(1)
  grid_res <- var_wflow |>
    tune_grid(cell_folds, grid = 2)

  expect_message(
    {
      set.seed(1)
      new_new_res <- var_wflow |>
        tune_sim_anneal(
          cell_folds,
          iter = 2,
          initial = grid_res,
          control = control_sim_anneal(verbose = FALSE)
        )
    },
    regex = "Optimizing roc_auc"
  )
  expect_true(nrow(collect_metrics(new_new_res)) == 12)
  expect_true(max(new_new_res$.iter) == 2)
  expect_true(sum(grepl("^initial", collect_metrics(new_new_res)$.config)) == 6)
  expect_equal(new_new_res, .Last.tune.result)
})


test_that("unfinalized parameters", {
  skip_on_cran()
  skip_on_os("windows")
  skip_on_os("linux")

  data(two_class_dat, package = "modeldata")

  set.seed(5046)
  bt <- bootstraps(two_class_dat, times = 5)

  rec_example <- recipe(Class ~ ., data = two_class_dat)

  # RF
  model_rf <- rand_forest(mtry = tune()) |>
    set_mode("classification") |>
    set_engine("ranger")

  wf_rf <- workflow() |>
    add_model(model_rf) |>
    add_recipe(rec_example)

  expect_message({
    set.seed(30)
    rf_res <- wf_rf |>
      tune_grid(resamples = bt, grid = 4)
  })

  expect_snapshot({
    set.seed(40)
    rf_res_finetune <- wf_rf |>
      tune_sim_anneal(resamples = bt, initial = rf_res)
  })

  # don't supply an initial grid (#39)
  expect_snapshot({
    set.seed(40)
    rf_res_finetune <- wf_rf |>
      tune_sim_anneal(resamples = bt)
  })
})

test_that("incompatible parameter objects", {
  skip_on_cran()

  skip_if_not_installed("ranger")
  skip_if_not_installed("modeldata")
  skip_if_not_installed("rsample")

  rf_spec <- parsnip::rand_forest(mode = "regression", mtry = tune::tune())

  set.seed(1)
  grid_with_bigger_range <-
    dials::grid_space_filling(dials::mtry(range = c(1, 16)))

  set.seed(1)
  car_folds <- rsample::vfold_cv(car_prices, v = 2)

  car_wflow <- workflows::workflow() |>
    workflows::add_formula(Price ~ .) |>
    workflows::add_model(rf_spec)

  set.seed(1)
  tune_res_with_bigger_range <- tune::tune_grid(
    car_wflow,
    resamples = car_folds,
    grid = grid_with_bigger_range
  )

  set.seed(1)
  parameter_set_with_smaller_range <-
    dials::parameters(dials::mtry(range = c(1, 5)))

  scrub_best <- function(lines) {
    has_best <- grepl("Initial best", lines)
    lines[has_best] <- ""
    lines
  }

  set.seed(1)
  expect_snapshot(error = TRUE, transform = scrub_best, {
    res <-
      tune_sim_anneal(
        car_wflow,
        param_info = parameter_set_with_smaller_range,
        resamples = car_folds,
        initial = tune_res_with_bigger_range,
        iter = 2
      )
  })
})

test_that("set event-level", {
  # See issue 40
  skip_if_not_installed("rpart")
  skip_if_not_installed("modeldata")
  skip_if_not_installed("yardstick")
  skip_if_not_installed("rsample")
  skip_on_cran()

  # ------------------------------------------------------------------------------

  set.seed(1)
  dat <- modeldata::sim_classification(500, intercept = 8)

  # We should get high sensitivity and low specificity when event_level = "first"
  # count(dat, class)
  # levels(dat$class)

  set.seed(2)
  rs <- vfold_cv(dat, strata = class)

  cart_spec <- decision_tree(min_n = tune()) |> set_mode("classification")

  stats <- metric_set(accuracy, sensitivity, specificity)

  # ------------------------------------------------------------------------------
  # high sensitivity and low specificity

  set.seed(3)
  cart_res_first <-
    cart_spec |>
    tune_sim_anneal(
      class ~ .,
      rs,
      control = control_sim_anneal(event_level = "first", verbose_iter = FALSE),
      metrics = stats
    )

  results_first <-
    cart_res_first |>
    collect_metrics() |>
    dplyr::filter(.metric != "accuracy") |>
    dplyr::select(.config, .metric, mean) |>
    tidyr::pivot_wider(
      id_cols = .config,
      names_from = .metric,
      values_from = mean
    )

  dir_check <- all(results_first$sensitivity > results_first$specificity)
  expect_true(dir_check)

  # ------------------------------------------------------------------------------
  # Now reversed

  set.seed(3)
  cart_res_second <-
    cart_spec |>
    tune_sim_anneal(
      class ~ .,
      rs,
      control = control_sim_anneal(
        event_level = "second",
        verbose_iter = FALSE
      ),
      metrics = stats
    )

  results_second <-
    cart_res_second |>
    collect_metrics() |>
    dplyr::filter(.metric != "accuracy") |>
    dplyr::select(.config, .metric, mean) |>
    tidyr::pivot_wider(
      id_cols = .config,
      names_from = .metric,
      values_from = mean
    )

  rev_dir_check <- all(results_second$sensitivity < results_second$specificity)
  expect_true(rev_dir_check)
})

#' Plot racing results
#'
#' Plot the model results over stages of the racing results. A line is given
#' for each submodel that was tested.
#' @param x A object with class `tune_results`
#' @return A ggplot object.
#' @export
plot_race <- function(x) {
  metric <- tune::.get_tune_metric_names(x)[1]
  ex_mtrc <- collect_metrics(x)

  if (any(names(ex_mtrc) == ".eval_time")) {
    eval_time <- min(ex_mtrc$.eval_time, na.rm = TRUE)
  } else {
    eval_time <- NULL
  }

  rs <-
    x |>
    dplyr::select(id, .order, .metrics) |>
    tidyr::unnest(cols = .metrics) |>
    dplyr::filter(.metric == metric)

  if (!is.null(eval_time) && any(names(rs) == ".eval_time")) {
    rs <- dplyr::filter(rs, .eval_time == eval_time)
  }

  .order <- sort(unique(rs$.order))
  purrr::map(.order, \(x) stage_results(x, rs)) |>
    purrr::list_rbind() |>
    ggplot2::ggplot(ggplot2::aes(
      x = stage,
      y = mean,
      group = .config,
      col = .config
    )) +
    ggplot2::geom_line(alpha = .5, show.legend = FALSE) +
    ggplot2::xlab("Analysis Stage") +
    ggplot2::ylab(metric) +
    ggplot2::scale_x_continuous(breaks = integer_breaks)
}

integer_breaks <- function(lims) {
  breaks <- pretty(lims)

  unique(round(breaks))
}

stage_results <- function(ind, x) {
  res <-
    x |>
    dplyr::filter(.order <= ind) |>
    dplyr::group_by(.config) |>
    dplyr::summarize(
      mean = mean(.estimate, na.rm = TRUE),
      n = sum(!is.na(.estimate)),
      .groups = "drop"
    ) |>
    dplyr::mutate(stage = ind) |>
    dplyr::ungroup() |>
    dplyr::filter(n == ind)
}

#' Efficient grid search via racing with win/loss statistics
#'
#' [tune_race_win_loss()] computes a set of performance metrics (e.g. accuracy or RMSE)
#'  for a pre-defined set of tuning parameters that correspond to a model or
#'  recipe across one or more resamples of the data. After an initial number of
#'  resamples have been evaluated, the process eliminates tuning parameter
#'  combinations that are unlikely to be the best results using a statistical
#'  model. For each pairwise combinations of tuning parameters, win/loss
#'  statistics are calculated and a logistic regression model is used to measure
#'  how likely each combination is to win overall.
#'
#' @inheritParams tune_race_anova
#' @references
#' Kuhn, M 2014. "Futility Analysis in the Cross-Validation of Machine Learning
#' Models." \url{https://arxiv.org/abs/1405.6974}.
#' @param ... Not currently used.
#' @details
#' The technical details of this method are described in Kuhn (2014).
#'
#' Racing methods are efficient approaches to grid search. Initially, the
#'  function evaluates all tuning parameters on a small initial set of
#'  resamples. The `burn_in` argument of [control_race()] sets the number of
#'  initial resamples.
#'
#' The performance statistics from the current set of resamples are converted
#' to win/loss/tie results. For example, for two parameters (`j` and `k`) in a
#' classification model that have each been resampled three times:
#'
#' \preformatted{
#'             |  area under the ROC curve |
#'             -----------------------------
#'    resample | parameter j | parameter k | winner
#'    ---------------------------------------------
#'        1    |    0.81     |     0.92    |   k
#'        2    |    0.95     |     0.94    |   j
#'        3    |    0.79     |     0.81    |   k
#'    ---------------------------------------------
#' }
#'
#' After the third resample, parameter `k` has a 2:1 win/loss ratio versus `j`.
#' Parameters with equal results are treated as a half-win for each setting.
#' These statistics are determined for all pairwise combinations of the
#' parameters and a Bradley-Terry model is used to model these win/loss/tie
#' statistics. This model can compute the ability of a parameter combination to
#' win overall. A confidence interval for the winning ability is computed and
#' any settings whose interval includes zero are retained for future resamples
#' (since it is not statistically different form the best results).
#'
#'
#' The next resample is used with the remaining parameter combinations and the
#'  statistical analysis is updated. More candidate parameters may be excluded
#'  with each new resample that is processed.
#'
#' The [control_race()] function contains parameters for the significance cutoff
#'  applied to the Bradley-Terry model results as well as other relevant arguments.
#'  The first metric in the `metrics` argument is the one that will be optimized.
#'
#' ## Censored regression models
#'
#' With dynamic performance metrics (e.g. Brier or ROC curves), performance is
#' calculated for every value of `eval_time` but the _first_ evaluation time
#' given by the user (e.g., `eval_time[1]`) is analyzed during racing.
#'
#' Also, values of `eval_time` should be less than the largest observed event
#' time in the training data. For many non-parametric models, the results beyond
#' the largest time corresponding to an event are constant (or `NA`).
#'
#' @examples
#' \donttest{
#' library(parsnip)
#' library(rsample)
#' library(dials)
#'
#' ## -----------------------------------------------------------------------------
#'
#' if (rlang::is_installed(c("discrim", "modeldata"))) {
#'   library(discrim)
#'   data(two_class_dat, package = "modeldata")
#'
#'   set.seed(6376)
#'   rs <- bootstraps(two_class_dat, times = 10)
#'
#'   ## -----------------------------------------------------------------------------
#'
#'   # optimize an regularized discriminant analysis model
#'   rda_spec <-
#'     discrim_regularized(frac_common_cov = tune(), frac_identity = tune()) |>
#'     set_engine("klaR")
#'
#'   ## -----------------------------------------------------------------------------
#'
#'   ctrl <- control_race(verbose_elim = TRUE)
#'
#'   set.seed(11)
#'   grid_wl <-
#'     rda_spec |>
#'     tune_race_win_loss(Class ~ ., resamples = rs, grid = 10, control = ctrl)
#'
#'   # Shows only the fully resampled parameters
#'   show_best(grid_wl, metric = "roc_auc")
#'
#'   plot_race(grid_wl)
#' }
#' }
#' @return An object with primary class `tune_race` in the same standard format
#' as objects produced by [tune::tune_grid()].
#' @seealso [tune::tune_grid()], [control_race()], [tune_race_anova()]
#' @export
tune_race_win_loss <- function(object, ...) {
  UseMethod("tune_race_win_loss")
}

#' @export
tune_race_win_loss.default <- function(object, ...) {
  msg <- paste0(
    "The first argument to {.fn tune_race_win_loss} should be either ",
    "a model or workflow."
  )
  cli::cli_abort(msg)
}

#' @export
tune_race_win_loss.recipe <-
  function(
    object,
    model,
    resamples,
    ...,
    param_info = NULL,
    grid = 10,
    metrics = NULL,
    eval_time = NULL,
    control = control_race()
  ) {
    tune::empty_ellipses(...)

    control <- parsnip::condense_control(control, control_race())

    tune_race_win_loss(
      model,
      preprocessor = object,
      resamples = resamples,
      param_info = param_info,
      grid = grid,
      metrics = metrics,
      control = control,
      eval_time = eval_time
    )
  }

#' @export
tune_race_win_loss.formula <-
  function(
    formula,
    model,
    resamples,
    ...,
    param_info = NULL,
    grid = 10,
    metrics = NULL,
    eval_time = NULL,
    control = control_race()
  ) {
    tune::empty_ellipses(...)

    control <- parsnip::condense_control(control, control_race())

    tune_race_win_loss(
      model,
      preprocessor = formula,
      resamples = resamples,
      param_info = param_info,
      grid = grid,
      metrics = metrics,
      eval_time = eval_time,
      control = control
    )
  }

#' @export
#' @rdname tune_race_win_loss
tune_race_win_loss.model_spec <-
  function(
    object,
    preprocessor,
    resamples,
    ...,
    param_info = NULL,
    grid = 10,
    metrics = NULL,
    eval_time = NULL,
    control = control_race()
  ) {
    if (
      rlang::is_missing(preprocessor) || !tune::is_preprocessor(preprocessor)
    ) {
      cli::cli_abort(
        "To tune a model spec, you must preprocess with a formula, recipe, \\
        or variable specification."
      )
    }

    tune::empty_ellipses(...)

    control <- parsnip::condense_control(control, control_race())

    wflow <- workflows::add_model(workflows::workflow(), object)

    if (tune::is_recipe(preprocessor)) {
      wflow <- workflows::add_recipe(wflow, preprocessor)
    } else if (rlang::is_formula(preprocessor)) {
      wflow <- workflows::add_formula(wflow, preprocessor)
    }

    tune_race_win_loss_workflow(
      wflow,
      resamples = resamples,
      grid = grid,
      metrics = metrics,
      eval_time = eval_time,
      param_info = param_info,
      control = control
    )
  }

#' @export
#' @rdname tune_race_win_loss
tune_race_win_loss.workflow <- function(
  object,
  resamples,
  ...,
  param_info = NULL,
  grid = 10,
  metrics = NULL,
  eval_time = NULL,
  control = control_race()
) {
  tune::empty_ellipses(...)

  control <- parsnip::condense_control(control, control_race())

  tune_race_win_loss_workflow(
    object,
    resamples = resamples,
    grid = grid,
    metrics = metrics,
    eval_time = eval_time,
    param_info = param_info,
    control = control
  )
}

## -----------------------------------------------------------------------------

tune_race_win_loss_workflow <-
  function(
    object,
    resamples,
    param_info = NULL,
    grid = 10,
    metrics = NULL,
    eval_time = NULL,
    control = control_race(),
    call = caller_env()
  ) {
    rlang::check_installed("BradleyTerry2")

    B <- nrow(resamples)
    if (control$randomize) {
      resamples <- randomize_resamples(resamples)
    }
    resamples <- dplyr::mutate(resamples, .order = dplyr::row_number())

    min_rs <- control$burn_in
    check_num_resamples(B, min_rs, call = call)
    tmp_resamples <- restore_rset(resamples, 1:min_rs)

    metrics <- tune::check_metrics_arg(metrics, object, call = call)
    eval_time <- tune::check_eval_time_arg(eval_time, metrics, call = call)

    grid_control <- parsnip::condense_control(control, tune::control_grid())
    res <-
      object |>
      tune::tune_grid(
        resamples = tmp_resamples,
        param_info = param_info,
        grid = grid,
        metrics = metrics,
        eval_time = eval_time,
        control = grid_control
      )

    param_names <- tune::.get_tune_parameter_names(res)

    opt_metric <- tune::first_metric(metrics)
    opt_metric_name <- opt_metric$metric
    maximize <- opt_metric$direction == "maximize"

    opt_metric_time <- tune::first_eval_time(
      metrics,
      metric = opt_metric_name,
      eval_time = eval_time,
      call = call
    )

    racing_obj_log(
      opt_metric_name,
      opt_metric$direction,
      control,
      opt_metric_time
    )

    filters_results <- test_parameters_bt(res, control$alpha, opt_metric_time)
    n_grid <- nrow(filters_results)

    log_final <- TRUE
    num_ties <- 0
    for (rs in (min_rs + 1):B) {
      if (sum(filters_results$pass) == 2) {
        num_ties <- num_ties + 1
      }
      new_grid <-
        filters_results |>
        dplyr::filter(pass) |>
        dplyr::select(!!!param_names)

      if (nrow(new_grid) > 1) {
        tmp_resamples <- restore_rset(resamples, rs)
        log_racing(
          control,
          filters_results,
          res$splits,
          n_grid,
          opt_metric_name
        )
      } else {
        tmp_resamples <- restore_rset(resamples, rs:B)
        if (log_final) {
          log_racing(
            control,
            filters_results,
            res$splits,
            n_grid,
            opt_metric_name
          )
        }
        log_final <- FALSE
      }

      grid_control <- parsnip::condense_control(control, tune::control_grid())
      tmp_res <-
        object |>
        tune::tune_grid(
          resamples = tmp_resamples,
          param_info = param_info,
          grid = new_grid,
          metrics = metrics,
          eval_time = eval_time,
          control = grid_control
        )
      res <- restore_tune(res, tmp_res, opt_metric_time)

      if (nrow(new_grid) > 1) {
        filters_results <- test_parameters_bt(
          res,
          control$alpha,
          opt_metric_time
        )
        if (sum(filters_results$pass) == 2 & num_ties >= control$num_ties) {
          filters_results <- tie_breaker(
            res,
            control,
            eval_time = opt_metric_time
          )
        }
      } else {
        # Depending on the value of control$parallel_over we don't need to do
        # the remaining loop to get the rs counter to B
        max_B <- max(tune::collect_metrics(res)$n)
        if (max_B == B) {
          break()
        }
      }
    }

    .stash_last_result(res)
    res
  }

test_that("top-level win/loss filter interfaces", {
  skip_on_cran()
  # Skip for < 4.0 due to random number differences
  skip_if(getRversion() < "4.0.0")

  library(dials)

  # ------------------------------------------------------------------------------

  set.seed(2332)
  folds <- vfold_cv(mtcars, v = 5, repeats = 2)
  fold_att <- attributes(folds)
  spec <- decision_tree(cost_complexity = tune(), min_n = tune()) |>
    set_engine("rpart") |>
    set_mode("regression")
  wflow <- workflow() |>
    add_model(spec) |>
    add_formula(mpg ~ .)
  grid <- expand.grid(cost_complexity = c(0.001, 0.01), min_n = c(2:5))
  rec <- recipe(mpg ~ ., data = mtcars) |>
    step_normalize(all_predictors())
  prm <- extract_parameter_set_dials(wflow) |> update(min_n = min_n(c(2, 20)))

  # ------------------------------------------------------------------------------

  set.seed(129)
  suppressWarnings(
    wl_mod <- spec |> tune_race_win_loss(mpg ~ ., folds, grid = grid)
  )

  expect_true(inherits(wl_mod, "tune_race"))
  expect_true(inherits(wl_mod, "tune_results"))
  expect_true(tibble::is_tibble((wl_mod)))
  expect_null(.get_tune_eval_times(wl_mod))
  expect_null(.get_tune_eval_time_target(wl_mod))

  expect_silent({
    set.seed(129)
    suppressWarnings(
      wl_wlfow <-
        wflow |>
        tune_race_win_loss(
          folds,
          grid = grid,
          param_info = prm,
          control = control_race(verbose_elim = FALSE, save_pred = TRUE)
        )
    )
  })

  expect_true(inherits(wl_wlfow, "tune_race"))
  expect_true(inherits(wl_wlfow, "tune_results"))
  expect_true(tibble::is_tibble((wl_wlfow)))
  expect_true(sum(names(wl_wlfow) == ".predictions") == 1)

  get_mod <- function(x) workflows::extract_fit_parsnip(x)

  expect_silent({
    set.seed(129)
    suppressMessages(
      wl_rec <-
        spec |>
        tune_race_win_loss(
          rec,
          folds,
          grid = expand.grid(cost_complexity = c(.0001, .001), min_n = c(3, 5)),
          param_info = prm,
          control = control_race(
            verbose_elim = FALSE,
            extract = get_mod
          )
        )
    )
  })

  expect_true(inherits(wl_rec, "tune_race"))
  expect_true(inherits(wl_rec, "tune_results"))
  expect_true(tibble::is_tibble((wl_rec)))
  expect_true(sum(names(wl_rec) == ".extracts") == 1)
})

test_that("formula interface", {
  skip_on_cran()

  expect_snapshot({
    set.seed(1)
    res <- f_wflow |>
      tune_race_win_loss(
        cell_folds,
        grid = 5,
        control = control_race(verbose_elim = TRUE)
      )
  })

  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) == 12) # this run has one elimination
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("recipe interface", {
  skip_on_cran()
  expect_silent({
    set.seed(1)
    res <- rec_wflow |>
      tune_race_win_loss(
        cell_folds,
        grid = 5,
        control = control_race(verbose_elim = FALSE)
      )
  })
  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) < 10)
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("variable interface", {
  skip_on_cran()
  expect_silent({
    set.seed(1)
    res <- var_wflow |>
      tune_race_win_loss(
        cell_folds,
        grid = 5,
        control = control_race(verbose_elim = FALSE)
      )
  })
  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) == 12) # one elimination
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("one player is really bad", {
  skip_on_cran()
  skip_if_not_installed("tune", "0.1.5.9001")

  set.seed(1341)
  df <- tibble(
    x1 = rnorm(500, 1:500),
    x2 = sample(c(1:4), size = 500, replace = T)
  ) |>
    mutate(
      y = rbinom(500, 1, prob = (x1 / max(x1))) |> as.factor()
    )

  set.seed(121)
  df_folds <- vfold_cv(df, strata = y)

  rf_spec <-
    rand_forest(trees = tune()) |>
    set_engine("ranger") |>
    set_mode("classification")

  wf <- workflow() |>
    add_formula(y ~ .) |>
    add_model(rf_spec)

  grid <- tibble(trees = c(1, 200))

  ctrl <- control_race(burn_in = 2, alpha = .05, randomize = TRUE)
  set.seed(3355)
  tuning_results <- tune_race_win_loss(
    wf,
    resamples = df_folds,
    metrics = metric_set(roc_auc),
    grid = grid,
    control = ctrl
  )

  expect_snapshot(best_res <- show_best(tuning_results))
  expect_true(nrow(best_res) == 1)
})

test_that("formula interface", {
  skip_on_cran()
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")

  expect_snapshot({
    set.seed(1)
    res <- f_wflow |>
      tune_race_anova(
        cell_folds,
        grid = grid_mod,
        control = control_race(verbose_elim = TRUE)
      )
  })
  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) < nrow(grid_mod) * 3)
  expect_equal(res, .Last.tune.result)
  expect_null(.get_tune_eval_times(res))
  expect_null(.get_tune_eval_time_target(res))
})

# ------------------------------------------------------------------------------

test_that("recipe interface", {
  skip_on_cran()
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")
  expect_silent({
    set.seed(1)
    res <- rec_wflow |>
      tune_race_anova(
        cell_folds,
        grid = grid_mod_rec,
        control = control_race(verbose_elim = FALSE)
      )
  })
  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) < nrow(grid_mod) * 3)
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("variable interface", {
  skip_on_cran()
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")

  expect_silent({
    set.seed(1)
    res <- var_wflow |>
      tune_race_anova(
        cell_folds,
        grid = grid_mod,
        control = control_race(verbose_elim = FALSE)
      )
  })
  expect_equal(
    class(res),
    c("tune_race", "tune_results", "tbl_df", "tbl", "data.frame")
  )
  expect_true(nrow(collect_metrics(res)) < nrow(grid_mod) * 3)
  expect_equal(res, .Last.tune.result)
})

# ------------------------------------------------------------------------------

test_that("too few resamples", {
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")

  rs <- rsample::vfold_cv(modeldata::cells, v = 2)
  expect_snapshot(
    error = TRUE,
    f_wflow |>
      tune_race_anova(
        rs,
        grid = grid_mod,
        control = control_race(verbose_elim = TRUE)
      )
  )
  expect_snapshot(
    error = TRUE,
    f_wflow |>
      tune_race_win_loss(
        rs,
        grid = grid_mod,
        control = control_race(verbose_elim = TRUE)
      )
  )
})

#' Control aspects of the grid search racing process
#'
#' @inheritParams tune::control_grid
#' @param verbose_elim A logical for whether logging of the elimination of
#'  tuning parameter combinations should occur.
#' @param burn_in An integer for how many resamples should be completed for all
#'  grid combinations before parameter filtering begins.
#' @param num_ties An integer for when tie-breaking should occur. If there are
#'  two final parameter combinations being evaluated, `num_ties` specified how
#'  many more resampling iterations should be evaluated. After `num_ties` more
#'  iterations, the parameter combination with the current best results is
#'  retained.
#' @param alpha The alpha level for a one-sided confidence interval for each
#'  parameter combination.
#' @param randomize Should the resamples be evaluated in a random order?  By
#' default, the resamples are evaluated in a random order so the random number
#' seed should be control prior to calling this method (to be reproducible).
#' For repeated cross-validation the randomization occurs within each repeat.
#' @return An object of class `control_race` that echos the argument values.
#' @examples
#' control_race()
#' @export
control_race <-
  function(
    verbose = FALSE,
    verbose_elim = FALSE,
    allow_par = TRUE,
    extract = NULL,
    save_pred = FALSE,
    burn_in = 3,
    num_ties = 10,
    alpha = 0.05,
    randomize = TRUE,
    pkgs = NULL,
    save_workflow = FALSE,
    event_level = "first",
    parallel_over = "everything",
    backend_options = NULL,
    workflow_size = 100
  ) {
    # Any added arguments should also be added in superset control functions
    # in other package. In other words, if tune_grid adds an option, the same
    # object should be added here (regardless)

    check_bool(verbose)
    check_bool(verbose_elim)
    check_bool(allow_par)
    check_number_decimal(alpha)
    check_number_whole(burn_in, min = 2)
    check_bool(randomize)
    check_number_whole(num_ties)
    check_bool(save_pred)
    check_character(pkgs, allow_null = TRUE)
    check_string(event_level)
    check_function(extract, allow_null = TRUE)
    check_bool(save_workflow)
    check_number_decimal(workflow_size)
    if (!is.null(parallel_over)) {
      rlang::arg_match0(parallel_over, c("resamples", "everything"))
    }

    if (alpha <= 0 | alpha >= 1) {
      cli::cli_abort("{.arg alpha} should be on (0, 1).")
    }

    res <- list(
      verbose = verbose,
      verbose_elim = verbose_elim,
      allow_par = allow_par,
      extract = extract,
      save_pred = save_pred,
      alpha = alpha,
      burn_in = burn_in,
      num_ties = num_ties,
      randomize = randomize,
      pkgs = pkgs,
      save_workflow = save_workflow,
      parallel_over = parallel_over,
      event_level = event_level,
      backend_options = backend_options,
      workflow_size = workflow_size
    )

    class(res) <- c("control_race")
    res
  }

#' @export
print.control_race <- function(x, ...) {
  cat("Racing method control object\n")
  invisible(x)
}

test_that("racing S3 methods", {
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")
  skip_if_not_installed("kknn")

  library(purrr)
  library(dplyr)
  library(parsnip)
  library(rsample)
  library(recipes)

  knn_mod_power <-
    nearest_neighbor(mode = "regression", dist_power = tune()) |>
    set_engine("kknn")

  simple_rec <- recipe(mpg ~ ., data = mtcars)

  set.seed(7898)
  race_folds <- vfold_cv(mtcars, repeats = 2)

  ctrl_rc <- control_race(save_pred = TRUE)
  set.seed(9323)
  anova_race <-
    tune_race_anova(
      knn_mod_power,
      simple_rec,
      resamples = race_folds,
      grid = tibble::tibble(dist_power = c(1 / 10, 1, 2)),
      control = ctrl_rc
    )

  # ------------------------------------------------------------------------------
  # collect metrics

  expect_equal(nrow(collect_metrics(anova_race)), 2)
  expect_equal(nrow(collect_metrics(anova_race, all_configs = TRUE)), 6)
  expect_equal(nrow(collect_metrics(anova_race, summarize = FALSE)), 2 * 20)
  expect_equal(
    nrow(collect_metrics(anova_race, summarize = FALSE, all_configs = TRUE)),
    nrow(map(anova_race$.metrics, \(x) x) |> list_rbind())
  )

  # ------------------------------------------------------------------------------
  # collect predictions

  expect_equal(
    nrow(collect_predictions(
      anova_race,
      all_configs = FALSE,
      summarize = TRUE
    )),
    nrow(mtcars) * 1 # 1 config x nrow(mtcars)
  )
  expect_equal(
    nrow(collect_predictions(anova_race, all_configs = TRUE, summarize = TRUE)),
    map(anova_race$.predictions, \(x) x) |>
      list_rbind() |>
      distinct(.config, .row) |>
      nrow()
  )
  expect_equal(
    nrow(collect_predictions(
      anova_race,
      all_configs = FALSE,
      summarize = FALSE
    )),
    nrow(mtcars) * 1 * 2 # 1 config x 2 repeats x nrow(mtcars)
  )
  expect_equal(
    nrow(collect_predictions(
      anova_race,
      all_configs = TRUE,
      summarize = FALSE
    )),
    nrow(map(anova_race$.predictions, \(x) x) |> list_rbind())
  )

  # ------------------------------------------------------------------------------
  # show_best and select_best

  expect_equal(nrow(show_best(anova_race, metric = "rmse")), 1)
  expect_true(all(show_best(anova_race, metric = "rmse")$n == 20))
  expect_equal(nrow(select_best(anova_race, metric = "rmse")), 1)
  expect_equal(
    nrow(select_by_pct_loss(
      anova_race,
      metric = "rmse",
      dist_power,
      limit = 10
    )),
    1
  )
  expect_equal(
    nrow(select_by_one_std_err(anova_race, metric = "rmse", dist_power)),
    1
  )
})

## -----------------------------------------------------------------------------

test_that("control_race arg passing", {
  expect_equal(control_race(verbose = TRUE)$verbose, TRUE)
  expect_equal(control_race(verbose_elim = TRUE)$verbose_elim, TRUE)
  expect_equal(control_race(burn_in = 13)$burn_in, 13)
  expect_equal(control_race(num_ties = 2)$num_ties, 2)
  expect_equal(control_race(alpha = .12)$alpha, .12)
  expect_equal(control_race(extract = function(x) x)$extract, function(x) x)
  expect_equal(control_race(save_pred = TRUE)$save_pred, TRUE)
  expect_equal(control_race(pkgs = "carrot")$pkgs, "carrot")
  expect_equal(control_race(save_workflow = TRUE)$save_workflow, TRUE)
})

test_that("control_race bad arg passing", {
  expect_snapshot(error = TRUE, control_race(verbose = "TRUE"))
  expect_snapshot(error = TRUE, control_race(verbose = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_race(verbose_elim = "TRUE"))
  expect_snapshot(error = TRUE, control_race(verbose_elim = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_race(allow_par = "TRUE"))
  expect_snapshot(error = TRUE, control_race(save_pred = "TRUE"))
  expect_snapshot(error = TRUE, control_race(save_pred = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_race(save_workflow = "TRUE"))
  expect_snapshot(error = TRUE, control_race(save_workflow = rep(TRUE, 2)))
  expect_snapshot(error = TRUE, control_race(randomize = "TRUE"))
  expect_snapshot(error = TRUE, control_race(burn_in = "yes"))
  expect_snapshot(error = TRUE, control_race(burn_in = 0:1))
  expect_snapshot(error = TRUE, control_race(burn_in = 1))
  expect_snapshot(error = TRUE, control_race(num_ties = "yes"))
  expect_snapshot(error = TRUE, control_race(num_ties = 0:1))
  expect_snapshot(error = TRUE, control_race(alpha = 0:1))
  expect_snapshot(error = TRUE, control_race(alpha = "huge"))
  expect_snapshot(error = TRUE, control_race(alpha = 1))
  expect_snapshot(error = TRUE, control_race(event_level = TRUE))
  expect_snapshot(error = TRUE, control_race(workflow_size = "big"))
  expect_snapshot(error = TRUE, control_race(pkg = 0:1))
  expect_snapshot(error = TRUE, control_race(extract = 0:1))
  expect_snapshot(error = TRUE, control_race(parallel_over = "other"))
})

test_that("casting control_race to control_grid", {
  expect_snapshot(parsnip::condense_control(control_race(), control_grid()))
})

maximize_metric <- function(x, metric) {
  metrics <- tune::.get_tune_metrics(x)
  metrics_data <- tune::metrics_info(metrics)
  x <- metrics_data$.metric[1]
  metrics_data$direction[metrics_data$.metric == metric] == "maximize"
}

# Might not use this function
treat_as_integer <- function(x, num_unique = 10) {
  param_type <- purrr::map_chr(x$object, \(x) x$type)
  is_int <- param_type == "integer"
  x_vals <- purrr::map(x$object, \(x) dials::value_seq(x, n = 200))
  x_vals <- purrr::map_int(x_vals, \(x) length(unique(x)))
  x_vals < num_unique & is_int
}

new_in_neighborhood <- function(
  current,
  hist_values,
  pset,
  radius = c(0.05, 0.15),
  flip = 0.1
) {
  current <- dplyr::select(current, !!!pset$id)
  param_type <- purrr::map_chr(pset$object, \(x) x$type)
  if (any(param_type == "double")) {
    dbl_nms <- pset$id[param_type == "double"]
    new_dbl <-
      random_real_neighbor(
        current |> dplyr::select(dplyr::all_of(dbl_nms)),
        hist_values = hist_values |> dplyr::select(dplyr::all_of(dbl_nms)),
        pset |> dplyr::filter(id %in% dbl_nms),
        r = radius
      )
    current[, dbl_nms] <- new_dbl
  }

  if (any(param_type == "integer")) {
    int_nms <- pset$id[param_type == "integer"]
    flip_one <- all(param_type == "integer")
    new_int <-
      random_integer_neighbor(
        current |> dplyr::select(dplyr::all_of(int_nms)),
        hist_values = hist_values |> dplyr::select(dplyr::all_of(int_nms)),
        pset |> dplyr::filter(id %in% int_nms),
        prob = flip,
        change = flip_one
      )
    current[, int_nms] <- new_int
  }

  if (any(param_type == "character")) {
    chr_nms <- pset$id[param_type == "character"]
    flip_one <- all(param_type == "character")
    new_chr <-
      random_discrete_neighbor(
        current |> dplyr::select(!!!chr_nms),
        pset |> dplyr::filter(id %in% chr_nms),
        prob = flip,
        change = flip_one
      )
    current[, chr_nms] <- new_chr
  }
  current
}

random_discrete_neighbor <- function(current, pset, prob, change) {
  pnames <- pset$id
  change_val <- runif(length(pnames)) <= prob
  if (change & !any(change_val)) {
    change_val[sample(seq_along(change_val), 1)] <- TRUE
  }
  if (any(change_val)) {
    new_vals <- pnames[change_val]
    for (i in new_vals) {
      current_val <- current[[i]]
      parm_obj <- pset$object[[which(pset$id == i)]]
      parm_obj$values <- setdiff(parm_obj$values, current_val)
      current[[i]] <- dials::value_sample(parm_obj, 1)
    }
  }
  current
}


random_integer_neighbor <- function(
  current,
  hist_values,
  pset,
  prob,
  change,
  retain = 1,
  tries = 500
) {
  candidates <-
    purrr::map(
      1:tries,
      \(x) random_integer_neighbor_calc(current, pset, prob, change)
    ) |>
    purrr::list_rbind()

  rnd <- tune::encode_set(candidates, pset, as_matrix = TRUE)
  sample_by_distance(rnd, hist_values, retain = retain, pset = pset)
}

random_integer_neighbor_calc <- function(current, pset, prob, change) {
  change_val <- runif(nrow(pset)) <= prob
  if (change & !any(change_val)) {
    change_val[sample(seq_along(change_val), 1)] <- TRUE
  }
  if (any(change_val)) {
    param_change <- pset$id[change_val]
    for (i in param_change) {
      prm <- pset$object[[which(pset$id == i)]]
      prm_rng <- prm$range$upper - prm$range$lower
      tries <- min(prm_rng + 1, 500)
      pool <- dials::value_seq(prm, n = tries)
      smol_range <- floor(prm_rng / 10) + 1
      val_diff <- abs(current[[i]] - pool)
      pool <- pool[val_diff <= smol_range & val_diff > 0]
      if (length(pool) > 1) {
        current[[i]] <- sample(pool, 1)
      } else if (length(pool) == 1) {
        current[[i]] <- pool
      }
    }
  }
  current
}

random_real_neighbor <- function(
  current,
  hist_values,
  pset,
  retain = 1,
  tries = 500,
  r = c(0.05, 0.15)
) {
  is_quant <- purrr::map_lgl(pset$object, inherits, "quant_param")
  current <- current[, is_quant]
  pset <- pset[is_quant, ]
  encoded <- tune::encode_set(current, pset, as_matrix = TRUE)

  num_param <- ncol(encoded)
  if (num_param > 1) {
    rnd <- rnorm(num_param * tries)
    rnd <- matrix(rnd, ncol = num_param)
    rnd <- t(apply(rnd, 1, function(x) x / sqrt(sum(x^2))))
    rnd <- rnd * runif(tries, min = min(r), max = max(r))
    rnd <- sweep(rnd, 2, as.vector(encoded), "+")
    outside <- apply(rnd, 1, function(x) any(x > 1 | x < 0))
    rnd <- rnd[!outside, , drop = FALSE]
  } else {
    rnd <- runif(tries, min = -max(r), max = max(r)) + encoded[[1]]
    rnd <- ifelse(rnd > 1, 1, rnd)
    rnd <- ifelse(rnd < 0, 0, rnd)
    rnd <- matrix(rnd, ncol = 1)
    rnd <- rnd[!duplicated(rnd), , drop = FALSE]
  }
  colnames(rnd) <- names(current)
  retain <- min(retain, nrow(rnd))

  sample_by_distance(rnd, hist_values, retain = retain, pset = pset)
}

encode_set_backwards <- function(x, pset, ...) {
  pset <- pset[pset$id %in% names(x), ]
  mapply(
    check_backwards_encode,
    pset$object,
    x,
    pset$id,
    SIMPLIFY = FALSE,
    USE.NAMES = FALSE
  )
  new_vals <- purrr::map2(
    pset$object,
    x,
    dials::encode_unit,
    direction = "backward"
  )
  names(new_vals) <- names(x)
  tibble::as_tibble(new_vals)
}

check_backwards_encode <- function(x, value, id) {
  if (!dials::has_unknowns(x)) {
    compl <- value[!is.na(value)]
    if (any(compl < 0) | any(compl > 1)) {
      cli::cli_abort(
        c(
          "!" = "The range for parameter {.val {noquote(id)}} used when \\
               generating initial results isn't compatible with the range \\
               supplied in {.arg param_info}.",
          "i" = "Possible values of parameters in {.arg param_info} should \\
               encompass all values evaluated in the initial grid."
        ),
        call = rlang::call2("tune_sim_anneal()")
      )
    }
  }
}

sample_by_distance <- function(candidates, existing, retain, pset) {
  if (nrow(existing) > 0) {
    existing <- tune::encode_set(existing, pset, as_matrix = TRUE)
    hist_index <- 1:nrow(existing)
    all_values <- rbind(existing, candidates)
    all_values <- stats::dist(all_values)
    all_values <- as.matrix(all_values)
    all_values <- all_values[hist_index, -hist_index, drop = FALSE]
    min_dist <- apply(all_values, 2, min)
    min_dist <- min_dist / max(min_dist)
    prob_wt <- min_dist^2
    prob_wt[is.na(prob_wt)] <- 0.0001

    if (diff(range(prob_wt)) < 0.0001) {
      prob_wt <- rep(1 / nrow(candidates), nrow(candidates))
    }
  } else {
    prob_wt <- rep(1 / nrow(candidates), nrow(candidates))
  }
  retain <- min(retain, nrow(candidates))

  candidates <- tibble::as_tibble(candidates)
  candidates <- encode_set_backwards(candidates, pset)

  selected <- sample(seq_along(prob_wt), size = retain, prob = prob_wt)
  candidates[selected, ]
}

## -----------------------------------------------------------------------------

update_history <- function(history, x, iter, eval_time) {
  analysis_metric <- tune::.get_tune_metric_names(x)[1]
  res <-
    tune::show_best(x, metric = analysis_metric, eval_time = eval_time) |>
    dplyr::mutate(
      .config = paste0("iter", iter),
      .iter = iter,
      random = runif(1),
      accept = NA_real_,
      results = NA_character_
    )
  if (is.null(history)) {
    history <- res
  } else {
    history <- dplyr::bind_rows(history, res)
  }

  if (maximize_metric(x, analysis_metric)) {
    best_res <- which.max(history$mean)
  } else {
    best_res <- which.min(history$mean)
  }

  history$global_best <- FALSE
  history$global_best[best_res] <- TRUE
  history
}

sa_decide <- function(x, parent, metric, maximize, coef) {
  res <- dplyr::filter(x, .metric == metric)
  latest_ind <- which.max(res$.iter)
  prev_ind <- which(res$.config == parent)
  prev_metric <- res$mean[prev_ind]
  latest_metric <- res$mean[latest_ind]
  all_prev <- res$mean[1:prev_ind]

  if (maximize) {
    is_best <- latest_metric > max(all_prev, na.rm = TRUE)
    is_better <- isTRUE(latest_metric > prev_metric)
  } else {
    is_best <- latest_metric < min(all_prev, na.rm = TRUE)
    is_better <- isTRUE(latest_metric < prev_metric)
  }

  m <- nrow(x)

  x$accept[m] <-
    acceptance_prob(
      current = prev_metric,
      new = latest_metric,
      iter = max(x$.iter),
      maximize = maximize,
      coef = coef
    )

  if (is_best) {
    x$results[m] <- "new best"
    x$random[m] <- x$accept[m] <- NA_real_
  } else if (is_better) {
    x$results[m] <- "better suboptimal"
    x$random[m] <- x$accept[m] <- NA_real_
  } else {
    if (x$random[m] <= x$accept[m]) {
      x$results[m] <- "accept suboptimal"
    } else {
      x$results[m] <- "discard suboptimal"
    }
  }
  x
}

initialize_history <- function(x, eval_time = NULL, ...) {
  # check to see if there is existing history
  res <-
    tune::collect_metrics(x) |>
    dplyr::filter(.metric == tune::.get_tune_metric_names(x)[1])
  if (!is.na(eval_time) && any(names(res) == ".eval_time")) {
    res <- res |> dplyr::filter(.eval_time == eval_time)
  }

  if (!any(names(res) == ".iter")) {
    res$.iter <- 0
  }

  res <-
    res |>
    dplyr::mutate(
      random = NA_real_,
      accept = NA_real_,
      results = "initial"
    )
  res
}


percent_diff <- function(current, new, maximize = TRUE) {
  if (isTRUE(all.equal(current, new))) {
    return(0.0)
  }
  if (maximize) {
    pct_diff <- (new - current) / current
  } else {
    pct_diff <- (current - new) / current
  }
  pct_diff * 100
}

acceptance_prob <- function(
  current,
  new,
  iter,
  maximize = TRUE,
  coef = 2 / 100
) {
  pct_diff <- percent_diff(current, new, maximize)
  if (pct_diff > 0) {
    return(1.0)
  }
  exp(pct_diff * coef * iter)
}

log_sa_progress <- function(
  control = list(verbose_iter = TRUE),
  x,
  metric,
  max_iter,
  maximize = TRUE,
  digits = 5
) {
  if (!control$verbose_iter) {
    return(invisible(NULL))
  }
  is_initial <- all(x$results == "initial")
  if (is_initial) {
    m <- max(which(x$global_best))
    new_res <- x$mean[m]
    new_std <- x$std_err[m]
    new_event <- x$results[m]
  } else {
    m <- nrow(x)
    new_res <- x$mean[m]
    new_std <- x$std_err[m]
    new_event <- x$results[m]
  }
  iter <- max(x$.iter)
  if (iter > 0 & !is_initial) {
    is_best <- isTRUE(x$global_best[m])
    prev_res <- x$mean[m - 1]
    pct_diff <- percent_diff(prev_res, new_res, maximize) * 100
    pct_diff <- sprintf("%6.2f", pct_diff)
  } else {
    is_best <- FALSE
    pct_diff <- NA_real_
  }

  chr_iter <- format(1:max_iter)[iter]
  dig <- paste0("%.", digits, "f")

  cols <- tune::get_tune_colors()
  if (iter > 0) {
    msg <- paste0(metric, "=", signif(new_res, digits = digits))
    if (!is.na(new_std) && new_std > 0) {
      msg <- paste0(msg, "\t(+/-", signif(new_std, digits = digits - 1), ")")
    }
    msg <- paste(chr_iter, format_event(new_event), msg)
  } else {
    if (maximize) {
      initial_res <- max(x$mean[x$.iter == 0], na.rm = TRUE)
    } else {
      initial_res <- min(x$mean[x$.iter == 0], na.rm = TRUE)
    }
    msg <- paste0(
      "Initial best: ",
      sprintf(dig, signif(initial_res, digits = digits))
    )
  }

  cli::cli_bullets(cols$message$info(msg))
}

# fmt: skip
format_event <- function(x) {
  result_key <- tibble::tribble(
    ~orig,               ~symb,
    "initial",            cli::symbol$tick,
    "new best",           cli::symbol$heart,
    "better suboptimal",  "+",
    "discard suboptimal", cli::symbol$line,
    "accept suboptimal",  cli::symbol$circle,
    "restart from best",  cli::symbol$cross
  ) |>
    dplyr::mutate(
      new = format(orig, justify = "left"),
      new = gsub(" ", "\u00a0", new, fixed = TRUE),
      result = paste(symb, new)
    )
  color_event(result_key$result[result_key$orig == x])
}

color_event <- function(x) {
  cols <- tune::get_tune_colors()
  dplyr::case_when(
    grepl("initial", x) ~ cols$symbol$info(x),
    grepl("new", x) ~ cols$symbol$success(x),
    grepl("better", x) ~ cols$symbol$success(x),
    grepl("discard", x) ~ cols$message$danger(x),
    grepl("accept", x) ~ cols$message$warning(x),
    grepl("restart", x) ~ cols$message$danger(x),
    TRUE ~ cols$message$info(x)
  )
}

get_outcome_names <- function(x, rs) {
  preproc <- extract_preprocessor(x)
  if (inherits(preproc, "workflow_variables")) {
    if (any(names(preproc) == "outcomes")) {
      dat <- rs$splits[[1]]$data
      res <- tidyselect::eval_select(preproc$outcomes, data = dat)
      res <- names(res)
    } else {
      cli::cli_abort("Cannot obtain the outcome name(s)")
    }
  } else {
    res <- outcome_names(x)
  }
  res
}

set_config <- function(x, config = NULL, prefix = NULL) {
  if (!is.null(x)) {
    if (!is.null(prefix)) {
      x <- dplyr::mutate(x, .config = paste0(prefix, "_", .config))
    } else {
      x <- dplyr::mutate(x, .config = config)
    }
  }
  x
}

update_config <- function(x, prefix = NULL, config = "new", save_pred) {
  if (!is.null(prefix)) {
    x$.metrics <-
      purrr::map(
        x$.metrics,
        \(x) set_config(x, prefix = prefix)
      )
    if (save_pred) {
      x$.predictions <-
        purrr::map(
          x$.predictions,
          \(x) set_config(x, prefix = prefix)
        )
    }
  } else {
    x$.metrics <-
      purrr::map(
        x$.metrics,
        \(x) set_config(x, config = config)
      )
    if (save_pred) {
      x$.predictions <-
        purrr::map(
          x$.predictions,
          \(x) set_config(x, config = config)
        )
    }
  }
  x
}

test_that("random integers in range", {
  set.seed(123)
  parameters <- dials::parameters(list(dials::tree_depth(range = c(2, 3))))
  random_integer_neigbors <-
    purrr::map(
      1:500,
      \(x)
        finetune:::random_integer_neighbor_calc(
          tibble::tibble(tree_depth = 3),
          parameters,
          0.75,
          FALSE
        )
    ) |>
    purrr::list_rbind()

  expect_true(all(random_integer_neigbors$tree_depth >= 2))
  expect_true(all(random_integer_neigbors$tree_depth <= 3))
})

test_that("numerical neighborhood", {
  suppressPackageStartupMessages(library(dials))

  num_prm <- dials::parameters(dials::mixture(), dials::threshold())

  vals <- tibble::tibble(mixture = 0.5, threshold = 0.5)
  set.seed(1)
  new_vals <-
    finetune:::random_real_neighbor(vals, vals[0, ], num_prm, retain = 100)

  rad <- control_sim_anneal()$radius

  correct_r <-
    purrr::map2_dbl(
      new_vals$mixture,
      new_vals$threshold,
      ~ sqrt((.x - .5)^2 + (.y - .5)^2)
    ) |>
    purrr::map_lgl(\(x) x >= rad[1] & x <= rad[2])
  expect_true(all(correct_r))

  set.seed(1)
  prev <- tibble::tibble(mixture = runif(5), threshold = runif(5))

  set.seed(2)
  more_vals <- finetune:::new_in_neighborhood(
    vals,
    prev,
    num_prm,
    radius = rep(0.12, 2)
  )
  rad_vals <- sqrt((more_vals$mixture - .5)^2 + (more_vals$threshold - .5)^2)
  expect_equal(rad_vals, 0.12, tolerance = 0.001)
})

test_that("numerical neighborhood boundary filters", {
  suppressPackageStartupMessages(library(dials))
  num_prm <- dials::parameters(dials::mixture(), dials::threshold())

  vals <- tibble::tibble(mixture = 0.05, threshold = 0.05)
  set.seed(1)
  new_vals <-
    finetune:::random_real_neighbor(
      vals,
      vals[0, ],
      num_prm,
      retain = 100,
      tries = 100,
      r = 0.12
    )
  expect_true(nrow(new_vals) < 100)
})

## -----------------------------------------------------------------------------

test_that("categorical value switching", {
  suppressPackageStartupMessages(library(dials))
  cat_prm <- parameters(activation(), weight_func())

  vals <- tibble::tibble(activation = "relu", weight_func = "biweight")
  set.seed(1)
  new_vals <-
    purrr::map(
      1:1000,
      \(x)
        finetune:::random_discrete_neighbor(
          vals,
          cat_prm,
          prob = 1 / 4,
          change = FALSE
        )
    ) |>
    purrr::list_rbind()
  relu_same <- mean(new_vals$activation == "relu")
  biweight_same <- mean(new_vals$weight_func == "biweight")

  expect_true(relu_same > .7 & relu_same < .8)
  expect_true(biweight_same > .7 & biweight_same < .8)

  set.seed(1)
  prev <- tibble::tibble(
    activation = dials::values_activation[1:4],
    weight_func = dials::values_weight_func[1:4]
  )
  set.seed(2)
  must_change <- finetune:::new_in_neighborhood(vals, prev, cat_prm, flip = 1)
  expect_true(must_change$activation != "relu")
  expect_true(must_change$weight_func != "biweight")
})

## -----------------------------------------------------------------------------

test_that("reverse-unit encoding", {
  suppressPackageStartupMessages(library(dials))
  prm <-
    parameters(batch_size(), Laplace(), activation()) |>
    update(Laplace = Laplace(c(2, 4)), batch_size = batch_size(c(10, 20)))
  unit_vals <- tibble::tibble(batch_size = .1, Laplace = .4, activation = .7)
  vals <- finetune:::encode_set_backwards(unit_vals, prm)
  expect_true(vals$batch_size > 1)
  expect_true(vals$Laplace > 1)
  expect_true(is.character(vals$activation))
})

load(file.path(test_path(), "sa_cart_test_objects.RData"))

## -----------------------------------------------------------------------------

cart_param <- tune::.get_tune_parameters(cart_search)
cart_metrics <- tune::.get_tune_metrics(cart_search)
cart_outcomes <- tune::.get_tune_outcome_names(cart_search)
cart_rset_info <- attributes(cart_search)$rset_info

## -----------------------------------------------------------------------------

test_that("simulated annealing decisions", {
  for (iter_val in 1:max(cart_history$.iter)) {
    iter_hist <- cart_history |> filter(.iter < iter_val)
    iter_res <-
      cart_search |>
      filter(.iter == iter_val) |>
      tune:::new_tune_results(
        parameters = cart_param,
        outcomes = cart_outcomes,
        metrics = cart_metrics,
        eval_time = NULL,
        eval_time_target = NULL,
        rset_info = cart_rset_info
      )
    iter_new_hist <- finetune:::update_history(
      iter_hist,
      iter_res,
      iter_val,
      NULL
    )
    iter_new_hist$random[1:nrow(iter_new_hist)] <- cart_history$random[
      1:nrow(iter_new_hist)
    ]

    expect_equal(
      iter_new_hist$mean[iter_new_hist$.iter == iter_val],
      cart_history$mean[cart_history$.iter == iter_val]
    )

    expect_equal(
      iter_new_hist$std_err[iter_new_hist$.iter == iter_val],
      cart_history$std_err[cart_history$.iter == iter_val]
    )

    new_sa_res <-
      finetune:::sa_decide(
        iter_new_hist,
        parent = cart_history$.parent[cart_history$.iter == iter_val],
        metric = "roc_auc",
        maximize = TRUE,
        coef = control_sim_anneal()$cooling_coef
      )

    expect_equal(
      new_sa_res$results[new_sa_res$.iter == iter_val],
      cart_history$results[cart_history$.iter == iter_val]
    )

    expect_equal(
      new_sa_res$accept[new_sa_res$.iter == iter_val],
      cart_history$accept[cart_history$.iter == iter_val]
    )
  }
})

## -----------------------------------------------------------------------------

test_that("percent difference", {
  expect_equal(finetune:::percent_diff(1, 2), 100)
  expect_equal(finetune:::percent_diff(1, 1), 0)
  expect_equal(finetune:::percent_diff(1, 2, FALSE), -100)
  expect_equal(finetune:::percent_diff(1, 1, FALSE), 0)
})


## -----------------------------------------------------------------------------

test_that("acceptance probabilities", {
  expect_equal(finetune:::acceptance_prob(1, 2, iter = 1, maximize = TRUE), 1)
  expect_equal(finetune:::acceptance_prob(1, 1, iter = 1, maximize = TRUE), 1)

  expect_equal(
    finetune:::acceptance_prob(2, 1, iter = 1, maximize = TRUE),
    exp(finetune:::percent_diff(2, 1) * 1 * control_sim_anneal()$cooling_coef)
  )
  expect_equal(
    finetune:::acceptance_prob(2, 1, iter = 10, maximize = TRUE),
    exp(finetune:::percent_diff(2, 1) * 10 * control_sim_anneal()$cooling_coef)
  )

  expect_equal(finetune:::acceptance_prob(3, 1, iter = 1, maximize = FALSE), 1)
  expect_equal(finetune:::acceptance_prob(3, 1, iter = 1, maximize = FALSE), 1)

  expect_equal(
    finetune:::acceptance_prob(1, 3, iter = 1, maximize = FALSE),
    exp(
      finetune:::percent_diff(1, 3, maximize = FALSE) *
        1 *
        control_sim_anneal()$cooling_coef
    )
  )
  expect_equal(
    finetune:::acceptance_prob(1, 3, iter = 10, maximize = FALSE),
    exp(
      finetune:::percent_diff(1, 3, maximize = FALSE) *
        10 *
        control_sim_anneal()$cooling_coef
    )
  )
})

## -----------------------------------------------------------------------------

test_that("logging results", {
  iters <- max(cart_history$.iter)

  for (i in 1:iters) {
    expect_message(
      finetune:::log_sa_progress(
        x = cart_history |> filter(.iter <= i),
        metric = "roc_auc",
        max_iter = i
      ),
      regexp = cart_history$results[cart_history$.iter == i]
    )
  }
})

options(dplyr.summarise.inform = FALSE)

## -----------------------------------------------------------------------------
# Racing via repeated measures ANOVA

mod2tibble <- function(x) {
  x |>
    tibble::as_tibble(rownames = ".config") |>
    dplyr::filter(grepl("\\.config", .config)) |>
    dplyr::mutate(.config = gsub("^\\.config", "", .config))
}

refactor_by_mean <- function(res, maximize = TRUE) {
  configs <-
    res |>
    dplyr::select(dplyr::starts_with("id"), .estimate, .config)

  ## ---------------------------------------------------------------------------
  # regroup .configs by mean and subset on those being analyzed

  best_config <-
    configs |>
    dplyr::group_by(.config) |>
    dplyr::summarize(
      mean = mean(.estimate, na.rm = TRUE),
      B = sum(!is.na(.estimate))
    ) |>
    dplyr::ungroup()

  max_resamples <- max(best_config$B, na.rm = TRUE)
  best_config <- best_config |> dplyr::filter(B == max_resamples)
  configs <- configs |> dplyr::filter(.config %in% best_config$.config)
  if (maximize) {
    config_levels <- best_config$.config[order(-best_config$mean)]
  } else {
    config_levels <- best_config$.config[order(best_config$mean)]
  }
  configs$.config <- factor(configs$.config, levels = config_levels)
  configs
}

test_parameters_gls <- function(x, alpha = 0.05, eval_time = NULL) {
  if (all(purrr::map_lgl(x$.metrics, is.null))) {
    cli::cli_abort("There were no valid metrics for the ANOVA model.")
  }
  param_names <- tune::.get_tune_parameter_names(x)
  metric_data <- metric_tibble(x)
  metric <- metric_data$metric[1]
  maximize <- metric_data$direction[1] == "maximize"

  res <-
    tune::collect_metrics(x, summarize = FALSE) |>
    dplyr::filter(.metric == metric)

  if (!is.null(eval_time) && any(names(res) == ".eval_time")) {
    res <- dplyr::filter(res, .eval_time == eval_time)
  }

  key <-
    res |>
    dplyr::select(!!!param_names, .config) |>
    dplyr::distinct()

  configs <- refactor_by_mean(res, maximize)

  ## ---------------------------------------------------------------------------

  mod_est <- fit_anova(x, configs, alpha)

  # rs_pct <-
  # lme4::VarCorr(mod) |>
  # tibble::as_tibble(rownames = "terms") |>
  # dplyr::mutate(var = sdcor^2, pct = var/sum(var)*100) |>
  # dplyr::filter(grp == "id") |>
  # dplyr::pull(pct) |>
  # round(2)

  # point_est <-
  #   coef(summary(mod)) |>
  #   mer2tibble() |>
  #   dplyr::select(.config, estimate = Estimate)
  # mod_est <-
  #   confint(mod, method = "Wald", level = 1 - alpha, quiet = TRUE) |>
  #   mer2tibble() |>
  #   setNames(c(".config", "lower", "upper")) |>
  #   dplyr::inner_join(point_est, by = ".config")

  if (maximize) {
    mod_est <-
      mod_est |>
      dplyr::mutate(pass = ifelse(upper > 0, TRUE, FALSE))
  } else {
    mod_est <-
      mod_est |>
      dplyr::mutate(pass = ifelse(lower < 0, TRUE, FALSE))
  }

  best_res <-
    tibble::tibble(
      .config = levels(configs$.config)[1],
      lower = 0,
      upper = 0,
      estimate = 0,
      pass = TRUE
    )

  dplyr::bind_rows(best_res, mod_est) |>
    dplyr::inner_join(key, by = ".config")
}


## -----------------------------------------------------------------------------
# Racing via discrete competitions

test_parameters_bt <- function(x, alpha = 0.05, eval_time = NULL) {
  param_names <- tune::.get_tune_parameter_names(x)
  metric_data <- metric_tibble(x)
  metric <- metric_data$metric[1]
  maximize <- metric_data$direction[1] == "maximize"

  res <-
    tune::collect_metrics(x, summarize = FALSE) |>
    dplyr::filter(.metric == metric)

  if (!is.null(eval_time) && any(names(res) == ".eval_time")) {
    res <- dplyr::filter(res, .eval_time == eval_time)
  }

  key <-
    res |>
    dplyr::select(!!!param_names, .config) |>
    dplyr::distinct()

  ## ---------------------------------------------------------------------------
  # Analyze data only on current candidate set

  num_resamples <-
    res |>
    dplyr::count(.config, name = "B")
  max_resamples <- max(num_resamples$B)
  analysis_config <-
    num_resamples |>
    dplyr::filter(B == max_resamples)
  analysis_data <- dplyr::inner_join(res, analysis_config, by = ".config")

  ## -----------------------------------------------------------------------------
  # Split data into all 2-way combinations of parameter configurations

  season_schedule <- make_config_pairs(analysis_data)
  # Eliminate pairs with all ties
  season_data <- score_season(season_schedule, analysis_data, maximize)

  best_team <- levels(season_data$scoring$player_1)[1]

  # Cases, esp with 2 players, where one player doesn't lose any games
  if (nrow(season_data$scoring) == 0) {
    return(mercy_rule(season_data, key))
  }

  best_team <- levels(season_data$scoring$player_1)[1]
  suppressWarnings(
    mod <- BradleyTerry2::BTm(
      cbind(wins_1, wins_2),
      player_1,
      player_2,
      data = season_data$scoring,
      br = TRUE
    )
  )

  q_val <- qt(1 - alpha, 1)
  mod_est <-
    summary(mod) |>
    purrr::pluck("coefficients") |>
    tibble::as_tibble(rownames = ".config") |>
    dplyr::select(.config, value = Estimate, std_err = `Std. Error`) |>
    dplyr::mutate(
      .config = gsub("^\\.\\.", "", .config),
      lower = value - q_val * std_err,
      upper = value + q_val * std_err,
      # The secondary conditions are for cases when a candidate set wins
      # a single competition.
      pass = ifelse(upper > 0 & std_err < 500, TRUE, FALSE)
    ) |>
    dplyr::bind_rows(make_best_results(best_team))

  ## TODO For both racing methods, make this a function with the configs as
  ## arguments.
  if (length(season_data$eliminated) > 0) {
    mod_est <- dplyr::bind_rows(
      mod_est,
      make_elim_results(season_data$eliminated)
    )
  }

  mod_est <-
    mod_est |>
    dplyr::inner_join(key, by = ".config")

  mod_est
}

make_config_pairs <- function(x) {
  ids <- unique(x$.config)
  id_combin <- t(utils::combn(ids, 2))
  colnames(id_combin) <- c("p1", "p2")
  id_combin <- tibble::as_tibble(id_combin)
  id_combin
}

score_match <- function(x, y, maximize) {
  if (maximize) {
    1.0 * (x > y) + sum(x == y) / 2
  } else {
    1.0 * sum(x < y) + sum(x == y) / 2
  }
}

make_best_results <- function(player) {
  tibble::tibble(
    .config = player,
    value = 0,
    std_err = 0,
    lower = 0,
    upper = 0,
    pass = TRUE
  )
}

make_elim_results <- function(players) {
  tibble::tibble(
    .config = players,
    value = NA_real_,
    std_err = NA_real_,
    lower = NA_real_,
    upper = NA_real_,
    pass = FALSE
  )
}

mercy_rule <- function(dat, key) {
  elim <- dat$eliminated
  lvls <- levels(dat$scoring$player_1)
  best <- lvls[!(lvls %in% elim)]
  dplyr::bind_rows(
    make_best_results(best),
    make_elim_results(elim)
  ) |>
    dplyr::inner_join(key, by = ".config")
}


score_season <- function(x, dat, maximize = FALSE) {
  # Determine how many matches each team has won. However, if a team loses
  # _all of its games_ (aka getting skunked), do not include it in the BT model
  # since it will have massively large standard errors and _not_ be eliminated
  # from the candidate set.
  # Because of this, we do some computations multiple times.

  ## -----------------------------------------------------------------------------

  # Look for zero-variance results and duplicated columns
  eliminated <- check_results(dat)
  x <- x |> dplyr::filter(!(p1 %in% eliminated) & !(p2 %in% eliminated))
  dat <- dat |> dplyr::filter(!(.config %in% eliminated))
  current_teams <- unique(dat$.config)

  ## -----------------------------------------------------------------------------

  player_1 <-
    dplyr::left_join(
      x |>
        dplyr::mutate(pair = dplyr::row_number()) |>
        dplyr::select(.config = p1, pair),
      dat,
      by = ".config",
      relationship = "many-to-many"
    ) |>
    dplyr::select(
      player_1 = .config,
      metric_1 = .estimate,
      pair,
      dplyr::starts_with("id")
    )

  player_2 <-
    dplyr::left_join(
      x |>
        dplyr::mutate(pair = dplyr::row_number()) |>
        dplyr::select(.config = p2, pair),
      dat,
      by = ".config",
      relationship = "many-to-many"
    ) |>
    dplyr::select(
      player_2 = .config,
      metric_2 = .estimate,
      pair,
      dplyr::starts_with("id")
    )

  game_results <-
    dplyr::full_join(
      player_1,
      player_2,
      by = c("id", "pair"),
      relationship = "many-to-many"
    ) |>
    dplyr::mutate(
      wins_1 = purrr::map2_dbl(
        metric_1,
        metric_2,
        score_match,
        maximize = maximize
      ),
      wins_2 = purrr::map2_dbl(
        metric_2,
        metric_1,
        score_match,
        maximize = maximize
      )
    )

  season_results <-
    game_results |>
    dplyr::group_by(player_1, player_2, pair) |>
    dplyr::summarize(
      wins_1 = sum(wins_1, na.rm = TRUE),
      wins_2 = sum(wins_2, na.rm = TRUE)
    ) |>
    dplyr::ungroup() |>
    dplyr::select(-pair)

  # Find overall rankings
  player_rankings <-
    dplyr::bind_rows(
      season_results |> dplyr::select(player = player_1, wins = wins_1),
      season_results |> dplyr::select(player = player_2, wins = wins_2)
    ) |>
    dplyr::group_by(player) |>
    dplyr::summarize(wins = sum(wins, na.rm = TRUE)) |>
    dplyr::ungroup() |>
    dplyr::arrange(dplyr::desc(wins))

  if (any(player_rankings$wins == 0)) {
    skunked <- player_rankings$player[player_rankings$wins == 0]
    eliminated <- c(eliminated, skunked)
    season_results <-
      game_results |>
      dplyr::filter(!(player_1 %in% skunked) & !(player_2 %in% skunked)) |>
      dplyr::group_by(player_1, player_2, pair) |>
      dplyr::summarize(
        wins_1 = sum(wins_1, na.rm = TRUE),
        wins_2 = sum(wins_2, na.rm = TRUE)
      ) |>
      dplyr::ungroup() |>
      dplyr::select(-pair)

    player_rankings <-
      dplyr::bind_rows(
        season_results |> dplyr::select(player = player_1, wins = wins_1),
        season_results |> dplyr::select(player = player_2, wins = wins_2)
      ) |>
      dplyr::group_by(player) |>
      dplyr::summarize(wins = sum(wins, na.rm = TRUE)) |>
      dplyr::ungroup() |>
      dplyr::arrange(dplyr::desc(wins))
  }

  if (nrow(season_results) == 0) {
    not_elim <- current_teams[!(current_teams %in% eliminated)]
    lvls <- c(not_elim, eliminated)
  } else {
    lvls <- player_rankings$player
  }

  res <-
    season_results |>
    dplyr::mutate(
      player_1 = factor(player_1, levels = lvls),
      player_2 = factor(player_2, levels = lvls)
    )
  list(scoring = res, eliminated = eliminated)
}

## -----------------------------------------------------------------------------
# Other helpers

# Since slicing rset or tune objects drops their attributes, these functions are
# used to reconstruct them temporarily

restore_rset <- function(x, index) {
  att <- attributes(x)
  x <- x |> dplyr::slice(index)
  att$row.names <- att$row.names[index]
  if (!is.null(att[[".resample_weights"]])) {
    att[[".resample_weights"]] <- att[[".resample_weights"]][index]
  }
  attributes(x) <- att
  x
}

get_configs <- function(x) {
  tune::collect_metrics(x) |>
    dplyr::distinct(!!!rlang::syms(tune::.get_tune_parameter_names(x)), .config)
}
merge_indiv_configs <- function(x, key) {
  orig_names <- names(x)
  param_names <- names(key)[names(key) != ".config"]
  dplyr::inner_join(x |> dplyr::select(-.config), key, by = param_names) |>
    dplyr::select(!!!orig_names)
}
harmonize_configs <- function(x, key) {
  x$.metrics <- purrr::map(x$.metrics, merge_indiv_configs, key = key)
  if (any(names(x) == ".predictions")) {
    x$.predictions <- purrr::map(x$.predictions, merge_indiv_configs, key = key)
  }
  if (any(names(x) == ".extracts")) {
    x$.extracts <- purrr::map(x$.extracts, merge_indiv_configs, key = key)
  }
  x
}

# restore_tune() restores certain attributes (esp class) that are lost during
# racing when rows of the resampling object are filtered.
# `x` has class `tune_results`. `y` has the same structure but different
# attributes.
# About eval_time_target: `x` is from `tune_grid()`, which has no notion of a
# target evaluation time. https://github.com/tidymodels/tune/pull/782 defaults
# `eval_time_target` to NULL for grid tuning, resampling, and last fit objects.
# That's why `eval_time_target` is an argument to this function. It should be
# non-null for the resulting racing object but the value inherited from `x` is
# NULL unless we set it.

restore_tune <- function(x, y, eval_time_target = NULL) {
  # With a smaller number of parameter combinations, the .config values may have
  # changed. We'll use the full set of parameters in `x` to adjust what is in
  # `y`.

  keys <- get_configs(x)
  y <- harmonize_configs(y, keys)

  ## -----------------------------------------------------------------------------

  att <- attributes(x)
  att$row.names <- 1:(nrow(x) + nrow(y))
  att$eval_time_target <- eval_time_target
  att$class <- c("tune_race", "tune_results", class(tibble::tibble()))

  ## -----------------------------------------------------------------------------

  x <- dplyr::bind_rows(tibble::as_tibble(x), tibble::as_tibble(y))
  attributes(x) <- att

  x
}

## -----------------------------------------------------------------------------

log_racing <- function(control, x, splits, grid_size, metric) {
  if (!control$verbose_elim) {
    return(invisible(NULL))
  }

  chr_seq <- format(0:grid_size)

  if (!is.null(splits)) {
    splits <- splits[[length(splits)]]
    labs <- labels(splits)
    labs <- rev(unlist(labs))
    labs <- paste0(labs, collapse = ", ")
    labs <- paste0(labs, ": ")
  }

  remaining <- sum(x$pass, na.rm = TRUE)
  num_elim <- sum(!x$pass, na.rm = TRUE)
  if (remaining > 1) {
    msg <- paste(
      chr_seq[num_elim + 1],
      "eliminated;",
      chr_seq[remaining + 1],
      "candidates remain."
    )
  } else {
    msg <- paste("All but one parameter combination were eliminated.")
  }

  tune_cols <- tune::get_tune_colors()
  msg <-
    tune_cols$message$info(
      paste0(cli::symbol$info, " ", labs, msg)
    )
  cli::cli_bullets(msg)
}

tie_breaker <- function(res, control, eval_time = NULL) {
  param_names <- tune::.get_tune_parameter_names(res)
  metrics <- tune::.get_tune_metrics(res)
  analysis_metric <- names(attr(metrics, "metrics"))[1]
  analysis_max <- attr(attr(metrics, "metrics")[[1]], "direction") == "maximize"
  metrics_time <- eval_time[1]

  x <-
    res |>
    tune::collect_metrics() |>
    dplyr::filter(.metric == analysis_metric)

  if (!is.null(metrics_time)) {
    x <- dplyr::filter(x, .eval_time == metrics_time)
  }

  all_config <- x$.config
  max_rs <- max(x$n)
  finalists <- x[x$n == max_rs, ]
  best <- finalists$.config[order(finalists$mean, decreasing = analysis_max)][1]
  if (control$verbose_elim) {
    tune_cols <- tune::get_tune_colors()
    msg <- tune_cols$symbol$info(paste0(cli::symbol$info, " Tie broken!"))
    if (runif(1) < .05) {
      msg <- paste(msg, "Two models enter, one model leaves.")
    }
    cli::cli_inform(msg)
  }
  res <-
    dplyr::select(x, .config, !!!param_names) |>
    dplyr::mutate(
      lower = 0,
      upper = 0,
      estimate = 0,
      pass = ifelse(.config == best, TRUE, FALSE)
    )
  res
}

check_results <- function(dat, rm_zv = TRUE, rm_dup = FALSE) {
  ids <- grep("^id", names(dat), value = TRUE)

  if (any(names(dat) == ".eval_time")) {
    dat$.eval_time <- NULL
  }

  x <-
    dat |>
    dplyr::select(!!!ids, .estimate, .config) |>
    tidyr::pivot_wider(
      id_cols = c(dplyr::all_of(ids)),
      names_from = .config,
      values_from = .estimate
    )

  exclude <- character(0)

  if (rm_dup) {
    tmp <- x[, !(names(x) %in% ids)]
    exclude <- c(exclude, names(tmp[duplicated(lapply(tmp, c))]))
    x <- x[, !(names(x) %in% exclude)]
  }

  if (rm_zv) {
    is_zv <- purrr::map_lgl(x, \(x) length(unique(x)) == 1)
    if (any(is_zv)) {
      exclude <- c(exclude, names(x)[is_zv])
      x <- x[, !(names(x) %in% exclude)]
    }
  }

  exclude
}


lmer_formula <- function(x, info) {
  f <- .estimate ~ .config + (1 | id)
  if (any(info$class == "vfold_cv") && info$repeats > 1) {
    ids <- x |> dplyr::select(id2, id)
    unique_res <- dplyr::count(ids, id)
    if (nrow(unique_res) > 1 && all(unique_res$n > 1)) {
      f <- .estimate ~ .config + (1 | id2 / id)
    } else {
      f <- .estimate ~ .config + (1 | .all_id)
    }
  }
  attr(f, ".Environment") <- rlang::base_env()
  f
}

fit_anova <- function(x, dat, alpha) {
  rs_info <- attr(x, "rset_info")$att
  if (any(rs_info$class == "vfold_cv") && rs_info$repeats > 1) {
    dat <- dplyr::mutate(dat, .all_id = paste(id2, id))
  }

  f <- lmer_formula(x, rs_info)

  suppressWarnings(
    suppressMessages(
      mod <- try(lme4::lmer(f, data = dat), silent = TRUE)
    )
  )

  if (inherits(mod, "try-error") || !isTRUE(mod@optinfo$conv$opt == 0)) {
    mod <- lm(.estimate ~ .config, data = dat)
  }
  point_est <-
    coef(summary(mod)) |>
    mod2tibble() |>
    dplyr::select(.config, estimate = Estimate)
  interval_est <-
    confint(mod, method = "Wald", level = 1 - alpha, quiet = TRUE) |>
    mod2tibble() |>
    setNames(c(".config", "lower", "upper"))

  dplyr::inner_join(point_est, interval_est, by = ".config")
}

## -----------------------------------------------------------------------------

metric_tibble <- function(x, ...) {
  metrics <- attributes(x)$metrics
  metrics <- attributes(metrics)$metrics
  directions <- purrr::map_chr(metrics, \(x) attr(x, "direction"))
  tibble::tibble(metric = names(metrics), direction = directions)
}

## -----------------------------------------------------------------------------

check_hidden_arg <- function(x, name, value) {
  if (!any(names(x) == name)) {
    return(FALSE)
  }
  identical(x[[name]], value)
}

# ------------------------------------------------------------------------------

randomize_resamples <- function(x) {
  att <- attributes(x)
  B <- nrow(x)
  x$.rand <- runif(B)
  x$.orig_order <- seq_len(B)
  reps <- attr(x, "repeats")
  if (!is.null(reps) && reps > 1) {
    x <- x |>
      dplyr::group_by(id) |>
      dplyr::arrange(.rand, .by_group = TRUE)
  } else {
    x <- x |> dplyr::arrange(.rand)
  }
  new_order <- x$.orig_order
  x$.rand <- NULL
  x$.orig_order <- NULL
  att$row.names <- att$row.names
  if (!is.null(att[[".resample_weights"]])) {
    att[[".resample_weights"]] <- att[[".resample_weights"]][new_order]
  }
  attributes(x) <- att
  x
}

# ------------------------------------------------------------------------------
# S3 methods

#' Obtain and format results produced by racing functions
#' @inheritParams tune::collect_predictions
#' @param all_configs A logical: should we return the complete set of model
#' configurations or just those that made it to the end of the race (the
#' default).
#' @export
#' @return A tibble. The column names depend on the results and the mode of the
#' model.
#' @details
#'
#' For [tune::collect_metrics()] and [tune::collect_predictions()], when unsummarized,
#' there are columns for each tuning parameter (using the `id` from [hardhat::tune()],
#' if any).
#' [tune::collect_metrics()] also has columns `.metric`, and `.estimator`.  When the
#' results are summarized, there are columns for `mean`, `n`, and `std_err`.
#' When not summarized, the additional columns for the resampling identifier(s)
#' and `.estimate`.
#'
#' For [tune::collect_predictions()], there are additional columns for the resampling
#' identifier(s), columns for the predicted values (e.g., `.pred`,
#' `.pred_class`, etc.), and a column for the outcome(s) using the original
#' column name(s) in the data.
#'
#' [tune::collect_predictions()] can summarize the various results over
#'  replicate out-of-sample predictions. For example, when using the bootstrap,
#'  each row in the original training set has multiple holdout predictions
#'  (across assessment sets). To convert these results to a format where every
#'  training set same has a single predicted value, the results are averaged
#'  over replicate predictions.
#'
#' For regression cases, the numeric predictions are simply averaged. For
#'  classification models, the problem is more complex. When class probabilities
#'  are used, these are averaged and then re-normalized to make sure that they
#'  add to one. If hard class predictions also exist in the data, then these are
#'  determined from the summarized probability estimates (so that they match).
#'  If only hard class predictions are in the results, then the mode is used to
#'  summarize.
#'
#' For racing results, it is best to only
#' collect model configurations that finished the race (i.e., were completely
#' resampled). Comparing performance metrics for configurations averaged with
#' different resamples is likely to lead to inappropriate results.
#' @name collect_predictions
collect_predictions.tune_race <-
  function(x, ..., summarize = FALSE, parameters = NULL, all_configs = FALSE) {
    rlang::check_dots_empty()
    x <- dplyr::select(x, -.order)
    res <- collect_predictions(
      x,
      summarize = summarize,
      parameters = parameters
    )
    if (!all_configs) {
      final_configs <- subset_finished_race(x)
      res <- dplyr::inner_join(res, final_configs, by = ".config")
    }
    res
  }

#' @inheritParams tune::collect_metrics
#' @export
#' @rdname collect_predictions
collect_metrics.tune_race <- function(
  x,
  ...,
  summarize = TRUE,
  type = c("long", "wide"),
  all_configs = FALSE
) {
  rlang::check_dots_empty()
  x <- dplyr::select(x, -.order)
  final_configs <- subset_finished_race(x)
  res <- collect_metrics(x, summarize = summarize, type = type)
  if (!all_configs) {
    final_configs <- subset_finished_race(x)
    res <- dplyr::inner_join(res, final_configs, by = ".config")
  }
  res
}

#' Investigate best tuning parameters
#'
#' [tune::show_best()] displays the top sub-models and their performance estimates.
#' @inheritParams tune::show_best
#' @rdname show_best
#' @param n An integer for the maximum number of top results/rows to return.
#' @details
#' For racing results (from the \pkg{finetune} package), it is best to only
#' report configurations that finished the race (i.e., were completely
#' resampled). Comparing performance metrics for configurations averaged with
#' different resamples is likely to lead to inappropriate results.
#' @export
show_best.tune_race <- function(
  x,
  ...,
  metric = NULL,
  eval_time = NULL,
  n = 5,
  call = rlang::current_env()
) {
  rlang::check_dots_empty()
  if (!is.null(metric)) {
    # What was used to judge the race and how are they being sorted now?
    metrics <- tune::.get_tune_metrics(x)
    tune::check_metric_in_tune_results(tibble::as_tibble(metrics), metric)
    opt_metric <- tune::first_metric(metrics)
    opt_metric_name <- opt_metric$metric
    if (metric[1] != opt_metric_name) {
      cli::cli_warn(
        "Metric {.val {opt_metric_name}} was used to evaluate model
                   candidates in the race but {.val {metric}} has been chosen
                   to rank the candidates. These results may not agree with the
                   race."
      )
    }
  }

  x <- dplyr::select(x, -.order)
  final_configs <- subset_finished_race(x)

  res <- NextMethod(
    metric = metric,
    eval_time = eval_time,
    n = Inf,
    call = call
  )
  res$.ranked <- 1:nrow(res)
  res <- dplyr::inner_join(res, final_configs, by = ".config")
  res$.ranked <- NULL
  n <- min(n, nrow(res))
  res[1:n, ]
}


# Only return configurations that were completely resampled
subset_finished_race <- function(x) {
  x <- dplyr::select(x, -dplyr::any_of(".order"))
  full_res <- tune::estimate_tune_results(x)
  # At least one configuration was completely resampled
  max_b <- max(full_res$n)
  final_configs <- dplyr::filter(full_res, n == max_b)
  final_configs <- dplyr::distinct(final_configs, .config)
  final_configs <- dplyr::select(final_configs, .config)
  final_configs
}

# ------------------------------------------------------------------------------
# Log the objective function used for racing

racing_obj_log <- function(
  analysis_metric,
  direction,
  control,
  metrics_time = NULL
) {
  cols <- tune::get_tune_colors()
  if (control$verbose_elim) {
    msg <- paste("Racing will", direction, "the", analysis_metric, "metric")

    if (!is.null(metrics_time)) {
      msg <- paste(msg, "at time", format(metrics_time, digits = 3))
    }
    msg <- paste0(msg, ".")

    cli::cli_inform(cols$message$info(paste0(cli::symbol$info, " ", msg)))
    if (control$randomize) {
      msg <- "Resamples are analyzed in a random order."
      cli::cli_inform(cols$message$info(paste0(cli::symbol$info, " ", msg)))
    }
  }
  invisible(NULL)
}

test_that("restore_rset subsets .resample_weights", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- c(0.5, 1.0, 1.5, 2.0, 2.5)
  attr(folds, ".resample_weights") <- weights

  result <- finetune:::restore_rset(folds, 1:3)

  expect_length(attr(result, ".resample_weights"), 3)
  expect_equal(attr(result, ".resample_weights"), weights[1:3])
})

test_that("restore_rset single-row subset returns single weight", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- c(0.5, 1.0, 1.5, 2.0, 2.5)
  attr(folds, ".resample_weights") <- weights

  result <- finetune:::restore_rset(folds, 2)

  expect_length(attr(result, ".resample_weights"), 1)
  expect_equal(attr(result, ".resample_weights"), 1.0)
})

test_that("restore_rset non-contiguous index maps weights correctly", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- c(0.5, 1.0, 1.5, 2.0, 2.5)
  attr(folds, ".resample_weights") <- weights

  result <- finetune:::restore_rset(folds, c(1, 3, 5))

  expect_length(attr(result, ".resample_weights"), 3)
  expect_equal(attr(result, ".resample_weights"), c(0.5, 1.5, 2.5))
})

test_that("restore_rset full index preserves all weights", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- c(0.5, 1.0, 1.5, 2.0, 2.5)
  attr(folds, ".resample_weights") <- weights

  result <- finetune:::restore_rset(folds, 1:5)

  expect_equal(attr(result, ".resample_weights"), weights)
})

test_that("restore_rset without weights keeps NULL", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)

  result <- finetune:::restore_rset(folds, 1:3)

  expect_null(attr(result, ".resample_weights"))
  expect_equal(nrow(result), 3)
})

test_that("randomize_resamples reorders weights to match rows", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- seq_len(nrow(folds)) * 10
  attr(folds, ".resample_weights") <- weights

  split_ids_before <- purrr::map_chr(folds$splits, ~ .x$id$id)

  set.seed(42)
  result <- finetune:::randomize_resamples(folds)

  split_ids_after <- purrr::map_chr(result$splits, ~ .x$id$id)
  result_weights <- attr(result, ".resample_weights")

  expect_length(result_weights, nrow(folds))

  for (i in seq_len(nrow(result))) {
    orig_pos <- which(split_ids_before == split_ids_after[i])
    expect_equal(result_weights[i], weights[orig_pos])
  }
})

test_that("randomize_resamples with repeated CV reorders weights", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 3, repeats = 2)
  weights <- seq_len(nrow(folds)) * 10
  attr(folds, ".resample_weights") <- weights

  id_pairs_before <- paste(folds$id, folds$id2)

  set.seed(42)
  result <- finetune:::randomize_resamples(folds)

  id_pairs_after <- paste(result$id, result$id2)
  result_weights <- attr(result, ".resample_weights")

  expect_length(result_weights, nrow(folds))

  for (i in seq_len(nrow(result))) {
    orig_pos <- which(id_pairs_before == id_pairs_after[i])
    expect_equal(result_weights[i], weights[orig_pos])
  }
})

test_that("randomize_resamples without weights keeps NULL, no column leaks", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  orig_names <- names(folds)

  set.seed(42)
  result <- finetune:::randomize_resamples(folds)

  expect_null(attr(result, ".resample_weights"))
  expect_equal(names(result), orig_names)
  expect_false(".orig_order" %in% names(result))
  expect_false(".rand" %in% names(result))
})

test_that("randomize then restore composes correctly", {
  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weights <- c(10, 20, 30, 40, 50)
  attr(folds, ".resample_weights") <- weights

  split_ids_orig <- purrr::map_chr(folds$splits, ~ .x$id$id)

  set.seed(42)
  randomized <- finetune:::randomize_resamples(folds)
  subset_idx <- 1:3
  restored <- finetune:::restore_rset(randomized, subset_idx)

  split_ids_restored <- purrr::map_chr(restored$splits, ~ .x$id$id)
  restored_weights <- attr(restored, ".resample_weights")

  expect_length(restored_weights, 3)

  for (i in seq_along(split_ids_restored)) {
    orig_pos <- which(split_ids_orig == split_ids_restored[i])
    expect_equal(restored_weights[i], weights[orig_pos])
  }
})

test_that("tune_race_anova works with weighted resamples", {
  skip_if_not(
    exists("add_resample_weights", where = asNamespace("tune"), inherits = FALSE),
    message = "tune::add_resample_weights not available"
  )

  set.seed(1)
  folds <- rsample::vfold_cv(mtcars, v = 5)
  weighted_folds <- tune::add_resample_weights(folds, rep(1, nrow(folds)))

  spec <- parsnip::decision_tree(
    cost_complexity = parsnip::tune(),
    min_n = parsnip::tune()
  ) |>
    parsnip::set_mode("regression") |>
    parsnip::set_engine("rpart")

  wflow <- workflows::workflow() |>
    workflows::add_model(spec) |>
    workflows::add_formula(mpg ~ .)

  grid <- expand.grid(cost_complexity = c(0.001, 0.01, 0.1), min_n = c(2, 5))

  expect_no_error({
    set.seed(42)
    result <- tune_race_anova(
      wflow,
      resamples = weighted_folds,
      grid = grid,
      control = control_race(verbose_elim = FALSE, verbose = FALSE)
    )
  })
})

## -----------------------------------------------------------------------------

test_that("anova filtering and logging", {
  # Skip for < 4.0 due to random number differences
  skip_if(getRversion() < "4.0.0")
  skip_if_not_installed("Matrix", "1.6-2")
  skip_if_not_installed("lme4", "1.1-35.1")

  set.seed(2332)
  folds <- vfold_cv(mtcars, v = 5, repeats = 2)
  fold_att <- attributes(folds)
  spec <-
    decision_tree(cost_complexity = tune(), min_n = tune()) |>
    set_engine("rpart") |>
    set_mode("regression")
  wflow <- workflow() |>
    add_model(spec) |>
    add_formula(mpg ~ .)
  grid <- expand.grid(cost_complexity = c(0.001, 0.01), min_n = c(2:5))

  ## -----------------------------------------------------------------------------

  grid_res <-
    spec |> tune_grid(mpg ~ ., folds, grid = grid, metrics = metric_set(rmse))
  # Pull out rmse values, format them to emulate the racing tests then
  # use lme4 package to create the model results for removing configurations.

  alpha <- 0.0381

  rmse_means <- collect_metrics(grid_res)
  configs <- rmse_means$.config[order(rmse_means$mean)]
  rmse_vals <- collect_metrics(grid_res, summarize = FALSE)
  rmse_configs <- rmse_vals
  rmse_configs$.config <- factor(rmse_configs$.config, levels = configs)
  rmse_configs <- rmse_configs[, c("id", "id2", ".estimate", ".config")]
  rmse_mod <- lmer(.estimate ~ .config + (1 | id2 / id), data = rmse_configs)
  rmse_summary <- summary(rmse_mod)$coef
  rmse_res <- tibble::as_tibble(rmse_summary)
  rmse_res$.config <- gsub("\\.config", "", rownames(rmse_summary))
  rmse_res$.config <- gsub(
    "(Intercept)",
    configs[1],
    rmse_res$.config,
    fixed = TRUE
  )
  rmse_ci <- confint(rmse_mod, level = 1 - alpha, method = "Wald", quiet = TRUE)
  rmse_ci <- rmse_ci[grepl("config", rownames(rmse_ci)), ]

  # ------------------------------------------------------------------------------
  # anova results

  anova_res <- finetune:::fit_anova(grid_res, rmse_configs, alpha = alpha)
  expect_equal(anova_res$estimate, rmse_res$Estimate[-1])
  expect_equal(anova_res$lower, unname(rmse_ci[, 1]))
  expect_equal(anova_res$upper, unname(rmse_ci[, 2]))
  expect_equal(anova_res$.config, configs[-1])

  # ------------------------------------------------------------------------------
  # top-level anova filter interfaces

  expect_snapshot({
    set.seed(129)
    anova_mod <- spec |> tune_race_anova(mpg ~ ., folds, grid = grid)
  })
  expect_true(inherits(anova_mod, "tune_race"))
  expect_true(inherits(anova_mod, "tune_results"))
  expect_true(tibble::is_tibble((anova_mod)))

  expect_silent({
    set.seed(129)
    anova_wlfow <-
      wflow |>
      tune_race_anova(
        folds,
        grid = grid,
        control = control_race(verbose_elim = FALSE, save_pred = TRUE)
      )
  })
  expect_true(inherits(anova_wlfow, "tune_race"))
  expect_true(inherits(anova_wlfow, "tune_results"))
  expect_true(tibble::is_tibble((anova_wlfow)))
  expect_true(sum(names(anova_wlfow) == ".predictions") == 1)

  ## -----------------------------------------------------------------------------
  ## anova formula

  for (i in 2:nrow(folds)) {
    f <- finetune:::lmer_formula(folds |> slice(1:i), fold_att)
    if (i < 7) {
      expect_equal(f, .estimate ~ .config + (1 | .all_id), ignore_attr = TRUE)
    } else {
      expect_equal(f, .estimate ~ .config + (1 | id2 / id), ignore_attr = TRUE)
    }
  }
  # This one takes a while to run:
  expect_equal(environment(f), rlang::base_env())

  car_bt <- bootstraps(mtcars, times = 5)
  car_att <- attributes(car_bt)

  for (i in 2:nrow(car_bt)) {
    f <- finetune:::lmer_formula(car_bt |> slice(1:i), car_att)
    expect_equal(f, .estimate ~ .config + (1 | id), ignore_attr = TRUE)
  }
  expect_equal(environment(f), rlang::base_env())

  res <- finetune:::refactor_by_mean(rmse_vals, maximize = FALSE)
  expect_equal(res, rmse_configs)

  # ------------------------------------------------------------------------------

  # Ue the built-in `ames_grid_search` object to test the object structure andU
  # printing

  param <- .get_tune_parameter_names(ames_grid_search)
  ames_grid_res <- collect_metrics(ames_grid_search)
  ames_grid_res <- ames_grid_res[ames_grid_res$.metric == "rmse", ]

  anova_res <- finetune:::test_parameters_gls(ames_grid_search)
  expect_equal(
    names(anova_res),
    # fmt: skip
    c(
      ".config", "lower", "upper", "estimate", "pass", "K", "weight_func",
      "dist_power", "lon", "lat"
    )
  )
  expect_equal(nrow(anova_res), nrow(ames_grid_res))
  expect_equal(anova_res$lower <= 0, anova_res$pass)
  expect_equal(
    anova_res |> dplyr::select(!!!param, .config) |> arrange(.config),
    ames_grid_res |> dplyr::select(!!!param, .config) |> arrange(.config)
  )

  expect_snapshot(
    finetune:::log_racing(
      control_race(verbose_elim = TRUE),
      anova_res,
      ames_grid_search$splits,
      10,
      "rmse"
    )
  )
  expect_snapshot(
    finetune:::log_racing(
      control_race(verbose_elim = TRUE),
      anova_res,
      ames_grid_search$splits,
      10,
      "rmse"
    )
  )
  expect_snapshot(
    finetune:::log_racing(
      control_race(verbose_elim = TRUE),
      anova_res,
      ames_grid_search$splits,
      10,
      "rmse"
    )
  )
})

#' Optimization of model parameters via simulated annealing
#'
#' [tune_sim_anneal()] uses an iterative search procedure to generate new
#'  candidate tuning parameter combinations based on previous results. It uses
#'  the generalized simulated annealing method of Bohachevsky, Johnson, and
#'  Stein (1986).
#'
#' @param object A `parsnip` model specification or a [workflows::workflow()].
#' @param preprocessor A traditional model formula or a recipe created using
#'   [recipes::recipe()]. This is only required when `object` is not a workflow.
#' @param resamples An `rset()` object.
#' @param param_info A [dials::parameters()] object or `NULL`. If none is given,
#' a parameter set is derived from other arguments. Passing this argument can
#' be useful when parameter ranges need to be customized.
#' @param metrics A [yardstick::metric_set()] object containing information on how
#' models will be evaluated for performance. The first metric in `metrics` is the
#' one that will be optimized.
#' @param eval_time A numeric vector of time points where dynamic event time
#' metrics should be computed (e.g. the time-dependent ROC curve, etc). The
#' values must be non-negative and should probably be no greater than the
#' largest event time in the training set (See Details below).
#' @param iter The maximum number of search iterations.
#' @param initial An initial set of results in a tidy format (as would the result
#' of [tune::tune_grid()], [tune::tune_bayes()], [tune_race_win_loss()], or
#' [tune_race_anova()]) or a positive integer. If the initial object was a
#' sequential search method, the simulated annealing iterations start after the
#' last iteration of the initial results.
#' @param control The results of [control_sim_anneal()].
#' @param ... Not currently used.
#' @details
#' Simulated annealing is a global optimization method. For model tuning, it
#'  can be used to iteratively search the parameter space for optimal tuning
#'  parameter combinations. At each iteration, a new parameter combination is
#'  created by perturbing the current parameters in some small way so that they
#'  are within a small neighborhood. This new parameter combination is used to
#'  fit a model and that model's performance is measured using resampling (or a
#'  simple validation set).
#'
#' If the new settings have better results than the current settings, they are
#'  accepted and the process continues.
#'
#' If the new settings has worse performance, a probability threshold is
#'  computed for accepting these sub-optimal values. The probability is a
#'  function of _how_ sub-optimal the results are as well as how many iterations
#'  have elapsed. This is referred to as the "cooling schedule" for the
#'  algorithm. If the sub-optimal results are accepted, the next iterations
#'  settings are based on these inferior results. Otherwise, new parameter
#'  values are generated from the previous iteration's settings.
#'
#' This process continues for a pre-defined number of iterations and the
#'  overall best settings are recommended for use. The [control_sim_anneal()]
#'  function can specify the number of iterations without improvement for early
#'  stopping. Also, that function can be used to specify a _restart_ threshold;
#'  if no globally best results have not be discovered within a certain number
#'  if iterations, the process can restart using the last known settings that
#'  globally best.
#'
#' ## Creating new settings
#'
#' For each numeric parameter, the range of possible values is known as well
#'  as any transformations. The current values are transformed and scaled to
#'  have values between zero and one (based on the possible range of values). A
#'  candidate set of values that are on a sphere with random radii between
#'  `rmin` and `rmax` are generated. Infeasible values are removed and one value
#'  is chosen at random. This value is back transformed to the original units
#'  and scale and are used as the new settings. The argument `radius` of
#'  [control_sim_anneal()] controls the range neighborhood sizes.
#'
#' For categorical and integer parameters, each is changes with a pre-defined
#'  probability. The `flip` argument of [control_sim_anneal()] can be used to
#'  specify this probability. For integer parameters, a nearby integer value is
#'  used.
#'
#' Simulated annealing search may not be the preferred method when many of the
#'  parameters are non-numeric or integers with few unique values. In these
#'  cases, it is likely that the same candidate set may be tested more than
#'  once.
#'
#'
#' ## Cooling schedule
#'
#' To determine the probability of accepting a new value, the percent
#'  difference in performance is calculated. If the performance metric is to be
#'  maximized, this would be `d = (new-old)/old*100`. The probability is
#'  calculated as `p = exp(d * coef * iter)` were `coef` is a user-defined
#'  constant that can be used to increase or decrease the probabilities.
#'
#' The `cooling_coef` of [control_sim_anneal()] can be used for this purpose.
#'
#' ## Termination criterion
#'
#' The restart counter is reset when a new global best results is found.
#'
#' The termination counter resets when a new global best is located or when a
#' suboptimal result is improved.
#'
#' ## Parallelism
#'
#' The `tune` and `finetune` packages currently parallelize over resamples.
#' Specifying a parallel back-end will improve the generation of the initial
#' set of sub-models (if any). Each iteration of the search are also run in
#' parallel if a parallel backend is registered.
#'
#' ## Censored regression models
#'
#' With dynamic performance metrics (e.g. Brier or ROC curves), performance is
#' calculated for every value of `eval_time` but the _first_ evaluation time
#' given by the user (e.g., `eval_time[1]`) is used to guide the optimization.
#'
#' Also, values of `eval_time` should be less than the largest observed event
#' time in the training data. For many non-parametric models, the results beyond
#' the largest time corresponding to an event are constant (or `NA`).
#'
#' @return A tibble of results that mirror those generated by [tune::tune_grid()].
#' However, these results contain an `.iter` column and replicate the `rset`
#' object multiple times over iterations (at limited additional memory costs).
#' @references
#' Bohachevsky, Johnson, and Stein (1986) "Generalized Simulated Annealing for
#' Function Optimization", _Technometrics_, 28:3, 209-217
#' @examples
#' \donttest{
#' library(finetune)
#' library(rpart)
#' library(dplyr)
#' library(tune)
#' library(rsample)
#' library(parsnip)
#' library(workflows)
#' library(ggplot2)
#'
#' ## -----------------------------------------------------------------------------
#' if (rlang::is_installed("modeldata")) {
#'   data(two_class_dat, package = "modeldata")
#'
#'   set.seed(5046)
#'   bt <- bootstraps(two_class_dat, times = 5)
#'
#'   ## -----------------------------------------------------------------------------
#'
#'   cart_mod <-
#'     decision_tree(cost_complexity = tune(), min_n = tune()) |>
#'     set_engine("rpart") |>
#'     set_mode("classification")
#'
#'   ## -----------------------------------------------------------------------------
#'
#'   # For reproducibility, set the seed before running.
#'   set.seed(10)
#'   sa_search <-
#'     cart_mod |>
#'     tune_sim_anneal(Class ~ ., resamples = bt, iter = 10)
#'
#'   autoplot(sa_search, metric = "roc_auc", type = "parameters") +
#'     theme_bw()
#'
#'   ## -----------------------------------------------------------------------------
#'   # More iterations. `initial` can be any other tune_* object or an integer
#'   # (for new values).
#'
#'   set.seed(11)
#'   more_search <-
#'     cart_mod |>
#'     tune_sim_anneal(Class ~ ., resamples = bt, iter = 10, initial = sa_search)
#'
#'   autoplot(more_search, metric = "roc_auc", type = "performance") +
#'     theme_bw()
#' }
#' }
#' @seealso [tune::tune_grid()], [control_sim_anneal()], [yardstick::metric_set()]
#' @export
tune_sim_anneal <- function(object, ...) {
  UseMethod("tune_sim_anneal")
}

#' @export
tune_sim_anneal.default <- function(object, ...) {
  msg <- paste0(
    "The first argument to {.fn tune_sim_anneal} should be either ",
    "a model or workflow."
  )
  cli::cli_abort(msg)
}

#' @export
tune_sim_anneal.recipe <- function(
  object,
  model,
  resamples,
  ...,
  iter = 10,
  param_info = NULL,
  metrics = NULL,
  eval_time = NULL,
  initial = 1,
  control = control_sim_anneal()
) {
  tune::empty_ellipses(...)

  control <- parsnip::condense_control(control, control_sim_anneal())

  tune_sim_anneal(
    model,
    preprocessor = object,
    resamples = resamples,
    iter = iter,
    param_info = param_info,
    metrics = metrics,
    eval_time = eval_time,
    initial = initial,
    control = control
  )
}

#' @export
tune_sim_anneal.formula <- function(
  formula,
  model,
  resamples,
  ...,
  iter = 10,
  param_info = NULL,
  metrics = NULL,
  eval_time = NULL,
  initial = 1,
  control = control_sim_anneal()
) {
  tune::empty_ellipses(...)

  control <- parsnip::condense_control(control, control_sim_anneal())

  tune_sim_anneal(
    model,
    preprocessor = formula,
    resamples = resamples,
    iter = iter,
    param_info = param_info,
    metrics = metrics,
    eval_time = eval_time,
    initial = initial,
    control = control
  )
}

#' @export
#' @rdname tune_sim_anneal
tune_sim_anneal.model_spec <- function(
  object,
  preprocessor,
  resamples,
  ...,
  iter = 10,
  param_info = NULL,
  metrics = NULL,
  eval_time = NULL,
  initial = 1,
  control = control_sim_anneal()
) {
  if (rlang::is_missing(preprocessor) || !tune::is_preprocessor(preprocessor)) {
    cli::cli_abort(
      "To tune a model spec, you must preprocess with a formula, recipe, \\
        or variable specification"
    )
  }

  tune::empty_ellipses(...)

  control <- parsnip::condense_control(control, control_sim_anneal())

  wflow <- workflows::add_model(workflows::workflow(), object)

  if (tune::is_recipe(preprocessor)) {
    wflow <- workflows::add_recipe(wflow, preprocessor)
  } else if (rlang::is_formula(preprocessor)) {
    wflow <- workflows::add_formula(wflow, preprocessor)
  }

  tune::initialize_catalog(control = control)

  tune_sim_anneal_workflow(
    wflow,
    resamples = resamples,
    iter = iter,
    param_info = param_info,
    metrics = metrics,
    eval_time = eval_time,
    initial = initial,
    control = control,
    ...
  )
}


#' @export
#' @rdname tune_sim_anneal
tune_sim_anneal.workflow <-
  function(
    object,
    resamples,
    ...,
    iter = 10,
    param_info = NULL,
    metrics = NULL,
    eval_time = NULL,
    initial = 1,
    control = control_sim_anneal()
  ) {
    tune::empty_ellipses(...)

    control <- parsnip::condense_control(control, control_sim_anneal())

    tune::initialize_catalog(control = control)

    tune_sim_anneal_workflow(
      object,
      resamples = resamples,
      iter = iter,
      param_info = param_info,
      metrics = metrics,
      eval_time = eval_time,
      initial = initial,
      control = control,
      ...
    )
  }

## -----------------------------------------------------------------------------

tune_sim_anneal_workflow <-
  function(
    object,
    resamples,
    iter = 10,
    param_info = NULL,
    metrics = NULL,
    eval_time = NULL,
    initial = 5,
    control = control_sim_anneal(),
    call = caller_env()
  ) {
    start_time <- proc.time()[3]
    cols <- tune::get_tune_colors()

    # ------------------------------------------------------------------------------
    # Check various inputs

    tune::check_rset(resamples)
    rset_info <- tune::pull_rset_attributes(resamples)

    metrics <- tune::check_metrics_arg(metrics, object, call = call)
    opt_metric <- tune::first_metric(metrics)
    opt_metric_name <- opt_metric$metric
    maximize <- opt_metric$direction == "maximize"

    eval_time <- tune::check_eval_time_arg(eval_time, metrics, call = call)
    opt_metric_time <- tune::first_eval_time(
      metrics,
      metric = opt_metric_name,
      eval_time = eval_time,
      call = call
    )

    if (is.null(param_info)) {
      param_info <- extract_parameter_set_dials(object)
    }

    # In case mtry or other parameters with missing ranges need finalization
    param_info <- tune::check_parameters(
      wflow = object,
      pset = param_info,
      data = resamples$splits[[1]]$data,
      grid_names = character(0)
    )

    tune::check_workflow(
      object,
      check_dials = !is.null(param_info),
      pset = param_info
    )

    # ------------------------------------------------------------------------------
    # Check or generate initial results

    control_init <- parsnip::condense_control(control, tune::control_grid())
    control_init$save_workflow <- TRUE
    initial <-
      tune::check_initial(
        initial,
        pset = param_info,
        wflow = object,
        resamples = resamples,
        metrics = metrics,
        eval_time = eval_time,
        ctrl = control_init
      )
    if (any(dials::has_unknowns(param_info$object))) {
      param_info <- tune::.get_tune_parameters(initial)
    }

    y_names <- get_outcome_names(object, resamples)
    # For the above, make changes to tune to get workflow from initial

    unsummarized <-
      initial |>
      tune::new_iteration_results(
        parameters = param_info,
        metrics = metrics,
        eval_time = eval_time,
        eval_time_target = opt_metric_time,
        outcomes = y_names,
        rset_info = rset_info,
        workflow = object
      ) |>
      update_config(prefix = "initial", save_pred = control$save_pred)

    mean_stats <- tune::estimate_tune_results(unsummarized)

    tune::check_time(start_time, control$time_limit)

    i <- max(unsummarized$.iter) # In case things fail before iteration.
    iter <- iter + i
    if (i > 0 && control$verbose_iter) {
      cli::cli_inform(cols$message$info(
        "There were ",
        i,
        " previous iterations"
      ))
    }

    on.exit({
      if (i < iter) {
        cli::cli_alert_danger(
          "Optimization stopped prematurely; returning current results."
        )
      }
      out <-
        tune::new_iteration_results(
          unsummarized,
          parameters = param_info,
          metrics = metrics,
          eval_time = eval_time,
          eval_time_target = opt_metric_time,
          outcomes = y_names,
          rset_info = rset_info,
          workflow = object
        )

      .stash_last_result(out)
      return(out)
    })

    if (control$verbose_iter) {
      msg <- paste("Optimizing", opt_metric_name)
      if (!is.null(opt_metric_time)) {
        msg <- paste(
          msg,
          "at evaluation time",
          format(opt_metric_time, digits = 3)
        )
      }
      cli::cli_bullets(msg)
    }

    ## -----------------------------------------------------------------------------

    result_history <- initialize_history(unsummarized, opt_metric_time)
    best_param <-
      tune::select_best(
        unsummarized,
        metric = opt_metric_name,
        eval_time = opt_metric_time
      ) |>
      dplyr::mutate(.parent = NA_character_)
    grid_history <- best_param
    current_param <- best_param
    current_parent <- best_param$.config
    global_param <- current_param

    result_history$global_best <- result_history$.config == current_parent

    existing_iter <- i

    ## -----------------------------------------------------------------------------

    count_improve <- count_restart <- 0

    log_sa_progress(
      control,
      x = result_history,
      max_iter = iter,
      maximize = maximize,
      metric = opt_metric_name
    )

    for (i in (existing_iter + 1):iter) {
      new_grid <-
        new_in_neighborhood(
          current_param,
          hist_values = grid_history,
          param_info,
          radius = control$radius,
          flip = control$flip
        ) |>
        dplyr::mutate(
          .config = paste0("iter", i),
          .parent = current_parent
        )
      grid_history <- dplyr::bind_rows(grid_history, new_grid)

      res <-
        object |>
        tune::tune_grid(
          resamples = resamples,
          grid = new_grid |> dplyr::select(-.config, -.parent),
          metrics = metrics,
          eval_time = eval_time,
          control = control_init
        ) |>
        dplyr::mutate(.iter = i) |>
        update_config(config = paste0("Iter", i), save_pred = control$save_pred)

      result_history <-
        result_history |>
        update_history(res, i, eval_time = opt_metric_time) |>
        sa_decide(
          parent = new_grid$.parent,
          metric = opt_metric_name,
          maximize = maximize,
          coef = control$cooling_coef
        )

      m <- nrow(result_history)

      if (result_history$results[m] == "new best") {
        global_param <- new_grid
        current_param <- new_grid
        current_parent <- current_param$.config
        best_param <- new_grid
        count_restart <- 0
        count_improve <- 0
      } else if (result_history$results[m] == "better suboptimal") {
        current_param <- new_grid
        current_parent <- current_param$.config
        best_param <- new_grid
        count_improve <- 0
        count_restart <- count_restart + 1
      } else if (result_history$results[m] == "accept suboptimal") {
        current_param <- new_grid
        current_parent <- current_param$.config
        count_improve <- count_improve + 1
        count_restart <- count_restart + 1
      } else {
        # discard
        count_improve <- count_improve + 1
        count_restart <- count_restart + 1
      }

      ## -----------------------------------------------------------------------------

      if (count_restart >= control$restart) {
        result_history$results[m] <- "restart from best"
        current_param <- global_param
        current_parent <- current_param$.config
        count_restart <- 0
      }

      ## -----------------------------------------------------------------------------

      unsummarized <-
        dplyr::bind_rows(unsummarized, res) |>
        tune::new_iteration_results(
          parameters = param_info,
          metrics = metrics,
          eval_time = eval_time,
          eval_time_target = opt_metric_time,
          outcomes = y_names,
          rset_info = rset_info,
          workflow = object
        )

      ## -----------------------------------------------------------------------------

      log_sa_progress(
        control,
        x = result_history,
        max_iter = iter,
        maximize = maximize,
        metric = opt_metric_name
      )

      if (count_improve >= control$no_improve) {
        cli::cli_inform(
          cols$message$danger(
            paste0("Stopping; no best in ", control$no_improve, " iterations.")
          )
        )
        break()
      }
    }

    if (control$save_history) {
      result_history <-
        result_history |>
        dplyr::full_join(
          grid_history |> dplyr::select(.config, .parent),
          by = ".config"
        ) |>
        dplyr::arrange(.iter, .config)
      save(result_history, file = file.path(tempdir(), "sa_history.RData"))
    }

    .stash_last_result(unsummarized)

    # Note; this line is probably not executed due to on.exit():
    unsummarized
  }

skip_if_not_installed("tune", minimum_version = "1.3.0.9006")

## -----------------------------------------------------------------------------

test_that("tune_sim_anneal interfaces", {
  skip_on_cran()
  skip_if_not_installed(c("discrim", "klaR"))

  library(discrim)
  data("two_class_dat", package = "modeldata")

  ## -----------------------------------------------------------------------------

  rda_spec <-
    discrim_regularized(frac_common_cov = tune(), frac_identity = tune()) |>
    set_engine("klaR")

  rda_param <- rda_spec |>
    extract_parameter_set_dials() |>
    update(
      frac_common_cov = frac_common_cov(c(.3, .6)),
      frac_identity = frac_identity(c(.3, .6))
    )

  set.seed(813)
  rs <- bootstraps(two_class_dat, times = 3)

  rec <- recipe(Class ~ ., data = two_class_dat) |>
    step_ns(A, deg_free = tune())

  # ------------------------------------------------------------------------------
  # formula interface

  expect_snapshot({
    set.seed(1)
    f_res_1 <- rda_spec |> tune_sim_anneal(Class ~ ., rs, iter = 3)
  })

  expect_snapshot({
    set.seed(1)
    f_res_2 <- rda_spec |>
      tune_sim_anneal(Class ~ ., rs, iter = 3, param_info = rda_param)
  })

  expect_true(all(collect_metrics(f_res_2)$frac_common_cov >= 0.3))
  expect_true(all(collect_metrics(f_res_2)$frac_common_cov <= 0.6))
  expect_true(all(collect_metrics(f_res_2)$frac_identity >= 0.3))
  expect_true(all(collect_metrics(f_res_2)$frac_identity <= 0.6))

  # ------------------------------------------------------------------------------
  # recipe interface

  expect_snapshot({
    set.seed(1)
    f_rec_1 <- rda_spec |> tune_sim_anneal(rec, rs, iter = 3)
  })
  expect_equal(sum(names(collect_metrics(f_rec_1)) == "deg_free"), 1)
  expect_equal(sum(names(collect_metrics(f_rec_1)) == "frac_common_cov"), 1)
  expect_equal(sum(names(collect_metrics(f_rec_1)) == "frac_identity"), 1)

  # ------------------------------------------------------------------------------
  # workflow interface

  wflow <-
    workflow() |>
    add_model(rda_spec) |>
    add_recipe(rec)

  expect_snapshot({
    set.seed(1)
    f_wflow_1 <- wflow |> tune_sim_anneal(rs, iter = 3)
  })
  expect_equal(sum(names(collect_metrics(f_wflow_1)) == "deg_free"), 1)
  expect_equal(sum(names(collect_metrics(f_wflow_1)) == "frac_common_cov"), 1)
  expect_equal(sum(names(collect_metrics(f_wflow_1)) == "frac_identity"), 1)
})

## -----------------------------------------------------------------------------

test_that("tune_sim_anneal with wrong type", {
  expect_snapshot(
    tune_sim_anneal(1),
    error = TRUE
  )
})

# ------------------------------------------------------------------------------

test_that("tune_sim_anneal loggining doesn't error with failed model", {
  # no failed results:
  res_1 <- purrr::map_dfr(
    ames_iter_search$.metrics,
    finetune:::set_config,
    config = "beratna"
  )
  expect_true(all(res_1$.config == "beratna"))

  has_failure <- tune:::vec_list_rowwise(ames_iter_search$.metrics[[1]])[1:3]
  has_failure[2] <- list(NULL)
  res_2 <- purrr::map(
    has_failure,
    finetune:::set_config,
    config = "sasa ke?"
  )
  expect_null(res_2[[2]])
  expect_equal(res_2[[1]]$.config, "sasa ke?")
  expect_equal(res_2[[3]]$.config, "sasa ke?")
})

suppressPackageStartupMessages(library(finetune))
suppressPackageStartupMessages(library(rsample))
suppressPackageStartupMessages(library(workflows))
suppressPackageStartupMessages(library(parsnip))
suppressPackageStartupMessages(library(dplyr))
suppressPackageStartupMessages(library(recipes))
suppressPackageStartupMessages(library(tibble))
suppressPackageStartupMessages(library(yardstick))
suppressPackageStartupMessages(library(purrr))
suppressPackageStartupMessages(library(lme4))
suppressPackageStartupMessages(library(ranger))
suppressPackageStartupMessages(library(recipes))
suppressPackageStartupMessages(library(modeldata))

# ------------------------------------------------------------------------------

data(cells, package = "modeldata")
cells <- modeldata::cells |> dplyr::select(class, contains("ch_1"))
set.seed(33)
cell_folds <- rsample::vfold_cv(cells, v = 3, repeats = 2)

## -----------------------------------------------------------------------------

cart_spec <-
  parsnip::decision_tree(
    cost_complexity = parsnip::tune(),
    min_n = parsnip::tune()
  ) |>
  parsnip::set_mode("classification") |>
  parsnip::set_engine("rpart")

cart_rec <-
  recipes::recipe(class ~ ., data = cells) |>
  recipes::step_normalize(recipes::all_predictors()) |>
  recipes::step_pca(recipes::all_predictors(), num_comp = parsnip::tune())

## -----------------------------------------------------------------------------

rec_wflow <-
  workflows::workflow() |>
  workflows::add_model(cart_spec) |>
  workflows::add_recipe(cart_rec)

f_wflow <-
  workflows::workflow() |>
  workflows::add_model(cart_spec) |>
  workflows::add_formula(class ~ .)

var_wflow <-
  workflows::workflow() |>
  workflows::add_model(cart_spec) |>
  workflows::add_variables(class, dplyr::everything())

# ------------------------------------------------------------------------------

grid_mod <-
  expand.grid(cost_complexity = c(0.001, 0.0001), min_n = c(3, 4))

grid_mod_rec <-
  expand.grid(cost_complexity = c(0.001, 0.0001), min_n = 3:4, num_comp = 19:20)

# ------------------------------------------------------------------------------

#' @keywords internal
"_PACKAGE"

## usethis namespace: start
## usethis namespace: end
NULL

# ------------------------------------------------------------------------------

#' @importFrom stats qt runif coef confint lm reorder rnorm setNames dist
#' @importFrom utils globalVariables
#' @importFrom rlang syms caller_env
#' @importFrom dplyr distinct
#' @importFrom utils globalVariables
#' @import tune
#' @import rlang
NULL

# ------------------------------------------------------------------------------

# fmt: skip
utils::globalVariables(
  c(
    ".config", ".estimate", ".iter", ".metric", ".parent", "B", "Estimate",
    "Std. Error", "lower", "metric_1", "metric_2", "n", "no_improve", "p1",
    "p2", "pair", "pass", "player", "player_1", "player_2", "std_err", "upper",
    "value", "wins", "wins_1", "wins_2", ".metrics", ".order", "id", "new",
    "orig", "stage", "symb", "id2", ".rand", ".eval_time"
  )
)

library(finetune)
library(rpart)
library(dplyr)
library(tune)
library(rsample)
library(parsnip)
library(workflows)
library(ggplot2)

## -----------------------------------------------------------------------------

data(two_class_dat, package = "modeldata")

set.seed(5046)
bt <- bootstraps(two_class_dat, times = 5)

## -----------------------------------------------------------------------------

cart_mod <-
  decision_tree(cost_complexity = tune(), min_n = tune()) |>
  set_engine("rpart") |>
  set_mode("classification")

## -----------------------------------------------------------------------------

ctrl <- control_sim_anneal(save_history = TRUE)

set.seed(2981)
# For reproducibility, set the seed before running.
cart_search <-
  cart_mod |>
  tune_sim_anneal(Class ~ ., resamples = bt, iter = 12, control = ctrl)

load(file.path(tempdir(), "sa_history.RData"))
cart_history <- result_history

save(
  cart_history,
  cart_search,
  file = file.path(testthat::test_path(), "sa_cart_test_objects.RData"),
  version = 2,
  compress = "xz"
)

if (!interactive()) {
  q("no")
}

#! /bin/bash
set -e
get_abs_filename() {
  echo "$(cd "$(dirname "$1")" && pwd)/$(basename "$1")"
}

ROOT_DIR=`dirname $0`
mkdir -p $ROOT_DIR/indico_tf_ops/build
cd $ROOT_DIR/indico_tf_ops/build
cmake ..
make

## Benchmarking results

To demonstrate, we use a SVM model with the `kernlab` package. 

```r
library(kernlab)
library(tidymodels)
library(finetune)
library(doParallel)

## -----------------------------------------------------------------------------

data(cells, package = "modeldata")
cells <- cells |> select(-case)

## -----------------------------------------------------------------------------

set.seed(6376)
rs <- bootstraps(cells, times = 25)
```

We'll only tune the model parameters (i.e., not recipe tuning): 

```r
## -----------------------------------------------------------------------------

svm_spec <-
  svm_rbf(cost = tune(), rbf_sigma = tune()) |>
  set_engine("kernlab") |>
  set_mode("classification")

svm_rec <-
  recipe(class ~ ., data = cells) |>
  step_YeoJohnson(all_predictors()) |>
  step_normalize(all_predictors())

svm_wflow <-
  workflow() |>
  add_model(svm_spec) |>
  add_recipe(svm_rec)

set.seed(1)
svm_grid <-
  svm_spec |>
  parameters() |>
  grid_latin_hypercube(size = 25)
```

We'll get the times for grid search and ANOVA racing with and without parallel processing: 

```r
## -----------------------------------------------------------------------------
## Regular grid search

system.time({
  set.seed(2)
  svm_wflow |> tune_grid(resamples = rs, grid = svm_grid)
})
```

```
##    user  system elapsed 
## 741.660  19.654 761.357 
```


```r
## -----------------------------------------------------------------------------
## With racing

system.time({
  set.seed(2)
  svm_wflow |> tune_race_anova(resamples = rs, grid = svm_grid)
})
```

```
##    user  system elapsed 
## 133.143   3.675 136.822 
```

Speed-up of 5.56-fold for racing. 


```r
## -----------------------------------------------------------------------------
## Parallel processing setup

cores <- parallel::detectCores(logical = FALSE)
cores
```

```
## [1] 10
```

```r
cl <- makePSOCKcluster(cores)
registerDoParallel(cl)
```


```r
## -----------------------------------------------------------------------------
## Parallel grid search

system.time({
  set.seed(2)
  svm_wflow |> tune_grid(resamples = rs, grid = svm_grid)
})
```

```
##  user  system elapsed 
## 1.112   0.190 126.650 
```

Parallel processing with grid search was 6.01-fold faster than sequential grid search.


```r
## -----------------------------------------------------------------------------
## Parallel racing

system.time({
  set.seed(2)
  svm_wflow |> tune_race_anova(resamples = rs, grid = svm_grid)
})
```

```
##  user  system elapsed 
## 1.908   0.261  21.442 
```

Parallel processing with racing was 35.51-fold faster than sequential grid search.

There is a compounding effect of racing and parallel processing but its magnitude depends on the type of model, number of resamples, number of tuning parameters, and so on. 

# control_sim_anneal bad arg passing

    Code
      control_sim_anneal(verbose = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `verbose` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(verbose = rep(TRUE, 2))
    Condition
      Error in `control_sim_anneal()`:
      ! `verbose` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_sim_anneal(verbose_iter = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `verbose_iter` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(save_pred = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `save_pred` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(save_pred = rep(TRUE, 2))
    Condition
      Error in `control_sim_anneal()`:
      ! `save_pred` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_sim_anneal(save_workflow = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `save_workflow` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(save_workflow = rep(TRUE, 2))
    Condition
      Error in `control_sim_anneal()`:
      ! `save_workflow` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_sim_anneal(save_history = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `save_history` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(allow_par = "TRUE")
    Condition
      Error in `control_sim_anneal()`:
      ! `allow_par` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_sim_anneal(no_improve = "yes")
    Condition
      Error in `control_sim_anneal()`:
      ! `no_improve` must be a whole number, not the string "yes".

---

    Code
      control_sim_anneal(no_improve = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `no_improve` must be a whole number, not an integer vector.

---

    Code
      control_sim_anneal(no_improve = 1)
    Condition
      Error in `control_sim_anneal()`:
      ! `no_improve` must be a whole number larger than or equal to 2, not the number 1.

---

    Code
      control_sim_anneal(restart = "yes")
    Condition
      Error in `control_sim_anneal()`:
      ! `restart` must be a whole number, not the string "yes".

---

    Code
      control_sim_anneal(restart = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `restart` must be a whole number, not an integer vector.

---

    Code
      control_sim_anneal(restart = 1)
    Condition
      Error in `control_sim_anneal()`:
      ! `restart` must be a whole number larger than or equal to 2, not the number 1.

---

    Code
      control_sim_anneal(no_improve = 2, restart = 6)
    Message
      ! Parameter restart is scheduled after 6 poor iterations but the search will stop after 2.
    Output
      Simulated annealing control object

---

    Code
      control_sim_anneal(radius = "huge")
    Condition
      Error in `control_sim_anneal()`:
      ! Argument `radius` should be two numeric values.

---

    Code
      control_sim_anneal(flip = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `flip` must be a number, not an integer vector.

---

    Code
      control_sim_anneal(flip = "huge")
    Condition
      Error in `control_sim_anneal()`:
      ! `flip` must be a number, not the string "huge".

---

    Code
      control_sim_anneal(cooling_coef = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `cooling_coef` must be a number, not an integer vector.

---

    Code
      control_sim_anneal(cooling_coef = "huge")
    Condition
      Error in `control_sim_anneal()`:
      ! `cooling_coef` must be a number, not the string "huge".

---

    Code
      control_sim_anneal(time_limit = "soon")
    Condition
      Error in `control_sim_anneal()`:
      ! `time_limit` must be a number or `NA`, not the string "soon".

---

    Code
      control_sim_anneal(pkg = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `pkgs` must be a character vector or `NULL`, not an integer vector.

---

    Code
      control_sim_anneal(extract = 0:1)
    Condition
      Error in `control_sim_anneal()`:
      ! `extract` must be a function or `NULL`, not an integer vector.

---

    Code
      control_sim_anneal(parallel_over = "other")
    Condition
      Error in `control_sim_anneal()`:
      ! `parallel_over` must be one of "resamples" or "everything", not "other".

# casting control_sim_anneal to control_grid

    Code
      parsnip::condense_control(control_sim_anneal(), control_grid())
    Message
      Grid/resamples control object
        `verbose`: FALSE
        `allow_par`: TRUE
        `extract`: NULL
        `save_pred`: FALSE
        `pkgs`: NULL
        `save_workflow`: FALSE
        `event_level`: "first"
        `parallel_over`: NULL
        `backend_options`: NULL
        `workflow_size`: 100

# tune_sim_anneal interfaces

    Code
      set.seed(1)
      f_res_1 <- tune_sim_anneal(rda_spec, Class ~ ., rs, iter = 3)
    Message
      Optimizing roc_auc
      Initial best: 0.85731
      1 ( ) accept suboptimal  roc_auc=0.85432 (+/-0.01039)
      2 <3 new best           roc_auc=0.86674 (+/-0.009097)
      3 <3 new best           roc_auc=0.87245 (+/-0.008363)

---

    Code
      set.seed(1)
      f_res_2 <- tune_sim_anneal(rda_spec, Class ~ ., rs, iter = 3, param_info = rda_param)
    Message
      Optimizing roc_auc
      Initial best: 0.85325
      1 ( ) accept suboptimal  roc_auc=0.85268 (+/-0.01056)
      2 <3 new best           roc_auc=0.85618 (+/-0.01015)
      3 <3 new best           roc_auc=0.85799 (+/-0.009991)

---

    Code
      set.seed(1)
      f_rec_1 <- tune_sim_anneal(rda_spec, rec, rs, iter = 3)
    Message
      Optimizing roc_auc
      Initial best: 0.86616
      1 ( ) accept suboptimal  roc_auc=0.86568 (+/-0.01027)
      2 <3 new best           roc_auc=0.86654 (+/-0.009714)
      3 <3 new best           roc_auc=0.8688 (+/-0.009487)

---

    Code
      set.seed(1)
      f_wflow_1 <- tune_sim_anneal(wflow, rs, iter = 3)
    Message
      Optimizing roc_auc
      Initial best: 0.86616
      1 ( ) accept suboptimal  roc_auc=0.86568 (+/-0.01027)
      2 <3 new best           roc_auc=0.86654 (+/-0.009714)
      3 <3 new best           roc_auc=0.8688 (+/-0.009487)

# tune_sim_anneal with wrong type

    Code
      tune_sim_anneal(1)
    Condition
      Error in `tune_sim_anneal()`:
      ! The first argument to `tune_sim_anneal()` should be either a model or workflow.

# anova filtering and logging

    Code
      set.seed(129)
      anova_mod <- tune_race_anova(spec, mpg ~ ., folds, grid = grid)

---

    Code
      finetune:::log_racing(control_race(verbose_elim = TRUE), anova_res,
      ames_grid_search$splits, 10, "rmse")
    Message
      i Fold10: 7 eliminated; 3 candidates remain.

---

    Code
      finetune:::log_racing(control_race(verbose_elim = TRUE), anova_res,
      ames_grid_search$splits, 10, "rmse")
    Message
      i Fold10: 7 eliminated; 3 candidates remain.

---

    Code
      finetune:::log_racing(control_race(verbose_elim = TRUE), anova_res,
      ames_grid_search$splits, 10, "rmse")
    Message
      i Fold10: 7 eliminated; 3 candidates remain.

# unfinalized parameters

    Code
      set.seed(40)
      rf_res_finetune <- tune_sim_anneal(wf_rf, resamples = bt, initial = rf_res)
    Message
      i Creating pre-processing data to finalize 1 unknown parameter: "mtry"
      Optimizing roc_auc
      Initial best: 0.84917
      1 ( ) accept suboptimal  roc_auc=0.84467 (+/-0.007843)
      2 <3 new best           roc_auc=0.84956 (+/-0.007013)
      3 ( ) accept suboptimal  roc_auc=0.84384 (+/-0.008042)
      4 + better suboptimal  roc_auc=0.84952 (+/-0.00757)
      5 ( ) accept suboptimal  roc_auc=0.84357 (+/-0.008148)
      6 + better suboptimal  roc_auc=0.84848 (+/-0.007499)
      7 ( ) accept suboptimal  roc_auc=0.84391 (+/-0.008097)
      8 + better suboptimal  roc_auc=0.84853 (+/-0.007036)
      9 ( ) accept suboptimal  roc_auc=0.84471 (+/-0.007812)
      10 x restart from best  roc_auc=0.84935 (+/-0.007313)

---

    Code
      set.seed(40)
      rf_res_finetune <- tune_sim_anneal(wf_rf, resamples = bt)
    Message
      i Creating pre-processing data to finalize 1 unknown parameter: "mtry"
      Optimizing roc_auc
      Initial best: 0.84369
      1 <3 new best           roc_auc=0.84929 (+/-0.007889)
      2 ( ) accept suboptimal  roc_auc=0.84461 (+/-0.008084)
      3 + better suboptimal  roc_auc=0.84785 (+/-0.007989)
      4 ( ) accept suboptimal  roc_auc=0.84325 (+/-0.007817)
      5 + better suboptimal  roc_auc=0.84917 (+/-0.007376)
      6 ( ) accept suboptimal  roc_auc=0.84458 (+/-0.007566)
      7 + better suboptimal  roc_auc=0.84871 (+/-0.007483)
      8 ( ) accept suboptimal  roc_auc=0.84431 (+/-0.007694)
      9 x restart from best  roc_auc=0.84861 (+/-0.007929)
      10 ( ) accept suboptimal  roc_auc=0.84522 (+/-0.008113)

# incompatible parameter objects

    Code
      res <- tune_sim_anneal(car_wflow, param_info = parameter_set_with_smaller_range,
        resamples = car_folds, initial = tune_res_with_bigger_range, iter = 2)
    Message
      Optimizing rmse
      
    Condition
      Error in `tune_sim_anneal()`:
      ! The range for parameter mtry used when generating initial results isn't compatible with the range supplied in `param_info`.
      i Possible values of parameters in `param_info` should encompass all values evaluated in the initial grid.
    Message
      x Optimization stopped prematurely; returning current results.

# control_race bad arg passing

    Code
      control_race(verbose = "TRUE")
    Condition
      Error in `control_race()`:
      ! `verbose` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(verbose = rep(TRUE, 2))
    Condition
      Error in `control_race()`:
      ! `verbose` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_race(verbose_elim = "TRUE")
    Condition
      Error in `control_race()`:
      ! `verbose_elim` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(verbose_elim = rep(TRUE, 2))
    Condition
      Error in `control_race()`:
      ! `verbose_elim` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_race(allow_par = "TRUE")
    Condition
      Error in `control_race()`:
      ! `allow_par` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(save_pred = "TRUE")
    Condition
      Error in `control_race()`:
      ! `save_pred` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(save_pred = rep(TRUE, 2))
    Condition
      Error in `control_race()`:
      ! `save_pred` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_race(save_workflow = "TRUE")
    Condition
      Error in `control_race()`:
      ! `save_workflow` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(save_workflow = rep(TRUE, 2))
    Condition
      Error in `control_race()`:
      ! `save_workflow` must be `TRUE` or `FALSE`, not a logical vector.

---

    Code
      control_race(randomize = "TRUE")
    Condition
      Error in `control_race()`:
      ! `randomize` must be `TRUE` or `FALSE`, not the string "TRUE".

---

    Code
      control_race(burn_in = "yes")
    Condition
      Error in `control_race()`:
      ! `burn_in` must be a whole number, not the string "yes".

---

    Code
      control_race(burn_in = 0:1)
    Condition
      Error in `control_race()`:
      ! `burn_in` must be a whole number, not an integer vector.

---

    Code
      control_race(burn_in = 1)
    Condition
      Error in `control_race()`:
      ! `burn_in` must be a whole number larger than or equal to 2, not the number 1.

---

    Code
      control_race(num_ties = "yes")
    Condition
      Error in `control_race()`:
      ! `num_ties` must be a whole number, not the string "yes".

---

    Code
      control_race(num_ties = 0:1)
    Condition
      Error in `control_race()`:
      ! `num_ties` must be a whole number, not an integer vector.

---

    Code
      control_race(alpha = 0:1)
    Condition
      Error in `control_race()`:
      ! `alpha` must be a number, not an integer vector.

---

    Code
      control_race(alpha = "huge")
    Condition
      Error in `control_race()`:
      ! `alpha` must be a number, not the string "huge".

---

    Code
      control_race(alpha = 1)
    Condition
      Error in `control_race()`:
      ! `alpha` should be on (0, 1).

---

    Code
      control_race(event_level = TRUE)
    Condition
      Error in `control_race()`:
      ! `event_level` must be a single string, not `TRUE`.

---

    Code
      control_race(workflow_size = "big")
    Condition
      Error in `control_race()`:
      ! `workflow_size` must be a number, not the string "big".

---

    Code
      control_race(pkg = 0:1)
    Condition
      Error in `control_race()`:
      ! `pkgs` must be a character vector or `NULL`, not an integer vector.

---

    Code
      control_race(extract = 0:1)
    Condition
      Error in `control_race()`:
      ! `extract` must be a function or `NULL`, not an integer vector.

---

    Code
      control_race(parallel_over = "other")
    Condition
      Error in `control_race()`:
      ! `parallel_over` must be one of "resamples" or "everything", not "other".

# casting control_race to control_grid

    Code
      parsnip::condense_control(control_race(), control_grid())
    Message
      Grid/resamples control object
        `verbose`: FALSE
        `allow_par`: TRUE
        `extract`: NULL
        `save_pred`: FALSE
        `pkgs`: NULL
        `save_workflow`: FALSE
        `event_level`: "first"
        `parallel_over`: "everything"
        `backend_options`: NULL
        `workflow_size`: 100

# formula interface

    Code
      set.seed(1)
      res <- tune_race_win_loss(f_wflow, cell_folds, grid = 5, control = control_race(
        verbose_elim = TRUE))
    Message
      i Racing will maximize the roc_auc metric.
      i Resamples are analyzed in a random order.
      i Fold3, Repeat1: 1 eliminated; 4 candidates remain.
      i Fold2, Repeat2: 0 eliminated; 4 candidates remain.
      i Fold3, Repeat2: 0 eliminated; 4 candidates remain.

# one player is really bad

    Code
      best_res <- show_best(tuning_results)
    Condition
      Warning in `show_best()`:
      No value of `metric` was given; "roc_auc" will be used.

# formula interface

    Code
      set.seed(1)
      res <- tune_race_anova(f_wflow, cell_folds, grid = grid_mod, control = control_race(
        verbose_elim = TRUE))
    Message
      i Evaluating against the initial 3 burn-in resamples.
      i Racing will maximize the roc_auc metric.
      i Resamples are analyzed in a random order.
      i Fold3, Repeat1: 2 eliminated; 2 candidates remain.
      i Fold2, Repeat2: All but one parameter combination were eliminated.

# too few resamples

    Code
      tune_race_anova(f_wflow, rs, grid = grid_mod, control = control_race(
        verbose_elim = TRUE))
    Condition
      Error in `tune_race_anova()`:
      ! The number of resamples (2) needs to be more than the number of burn-in resamples (3) set by the control function `control_race()`.

---

    Code
      tune_race_win_loss(f_wflow, rs, grid = grid_mod, control = control_race(
        verbose_elim = TRUE))
    Condition
      Error in `tune_race_win_loss()`:
      ! The number of resamples (2) needs to be more than the number of burn-in resamples (3) set by the control function `control_race()`.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/control_race.R
\name{control_race}
\alias{control_race}
\title{Control aspects of the grid search racing process}
\usage{
control_race(
  verbose = FALSE,
  verbose_elim = FALSE,
  allow_par = TRUE,
  extract = NULL,
  save_pred = FALSE,
  burn_in = 3,
  num_ties = 10,
  alpha = 0.05,
  randomize = TRUE,
  pkgs = NULL,
  save_workflow = FALSE,
  event_level = "first",
  parallel_over = "everything",
  backend_options = NULL,
  workflow_size = 100
)
}
\arguments{
\item{verbose}{A logical for logging results (other than warnings and errors,
which are always shown) as they are generated during training in a single
R process. When using most parallel backends, this argument typically will
not result in any logging. If using a dark IDE theme, some logging messages
might be hard to see; try setting the \code{tidymodels.dark} option with
\code{options(tidymodels.dark = TRUE)} to print lighter colors.}

\item{verbose_elim}{A logical for whether logging of the elimination of
tuning parameter combinations should occur.}

\item{allow_par}{A logical to allow parallel processing (if a parallel
backend is registered).}

\item{extract}{An optional function with at least one argument (or \code{NULL})
that can be used to retain arbitrary objects from the model fit object,
recipe, or other elements of the workflow.}

\item{save_pred}{A logical for whether the out-of-sample predictions should
be saved for each model \emph{evaluated}.}

\item{burn_in}{An integer for how many resamples should be completed for all
grid combinations before parameter filtering begins.}

\item{num_ties}{An integer for when tie-breaking should occur. If there are
two final parameter combinations being evaluated, \code{num_ties} specified how
many more resampling iterations should be evaluated. After \code{num_ties} more
iterations, the parameter combination with the current best results is
retained.}

\item{alpha}{The alpha level for a one-sided confidence interval for each
parameter combination.}

\item{randomize}{Should the resamples be evaluated in a random order?  By
default, the resamples are evaluated in a random order so the random number
seed should be control prior to calling this method (to be reproducible).
For repeated cross-validation the randomization occurs within each repeat.}

\item{pkgs}{An optional character string of R package names that should be
loaded (by namespace) during parallel processing.}

\item{save_workflow}{A logical for whether the workflow should be appended
to the output as an attribute.}

\item{event_level}{A single string containing either \code{"first"} or \code{"second"}.
This argument is passed on to yardstick metric functions when any type
of class prediction is made, and specifies which level of the outcome
is considered the "event".}

\item{parallel_over}{A single string containing either \code{"resamples"} or
\code{"everything"} describing how to use parallel processing. Alternatively,
\code{NULL} is allowed, which chooses between \code{"resamples"} and \code{"everything"}
automatically.

If \code{"resamples"}, then tuning will be performed in parallel over resamples
alone. Within each resample, the preprocessor (i.e. recipe or formula) is
processed once, and is then reused across all models that need to be fit.

If \code{"everything"}, then tuning will be performed in parallel at two levels.
An outer parallel loop will iterate over resamples. Additionally, an
inner parallel loop will iterate over all unique combinations of
preprocessor and model tuning parameters for that specific resample. This
will result in the preprocessor being re-processed multiple times, but
can be faster if that processing is extremely fast.

If \code{NULL}, chooses \code{"resamples"} if there are more than one resample,
otherwise chooses \code{"everything"} to attempt to maximize core utilization.

Note that switching between \code{parallel_over} strategies is not guaranteed
to use the same random number generation schemes. However, re-tuning a
model using the same \code{parallel_over} strategy is guaranteed to be
reproducible between runs.}

\item{backend_options}{An object of class \code{"tune_backend_options"} as created
by \code{tune::new_backend_options()}, used to pass arguments to specific tuning
backend. Defaults to \code{NULL} for default backend options.}

\item{workflow_size}{A non-negative number (in MB) that is used as a
threshold for a warning regarding the size of the workflow. Only used when
\code{save_workflow = TRUE}.}
}
\value{
An object of class \code{control_race} that echos the argument values.
}
\description{
Control aspects of the grid search racing process
}
\examples{
control_race()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/racing_helpers.R
\name{show_best.tune_race}
\alias{show_best.tune_race}
\title{Investigate best tuning parameters}
\usage{
\method{show_best}{tune_race}(
  x,
  ...,
  metric = NULL,
  eval_time = NULL,
  n = 5,
  call = rlang::current_env()
)
}
\arguments{
\item{x}{The results of \code{\link[tune:tune_grid]{tune_grid()}} or \code{\link[tune:tune_bayes]{tune_bayes()}}.}

\item{...}{For \code{\link[tune:select_by_one_std_err]{select_by_one_std_err()}} and \code{\link[tune:select_by_pct_loss]{select_by_pct_loss()}}, this
argument is passed directly to \code{\link[dplyr:arrange]{dplyr::arrange()}} so that the user can sort
the models from \emph{most simple to most complex}. That is, for a parameter \code{p},
pass the unquoted expression \code{p} if smaller values of \code{p} indicate a simpler
model, or \code{desc(p)} if larger values indicate a simpler model. At
least one term is required for these two functions. See the examples below.}

\item{metric}{A character value for the metric that will be used to sort
the models. (See
\url{https://yardstick.tidymodels.org/articles/metric-types.html} for
more details). Not required if a single metric exists in \code{x}. If there are
multiple metric and none are given, the first in the metric set is used (and
a warning is issued).}

\item{eval_time}{A single numeric time point where dynamic event time
metrics should be chosen (e.g., the time-dependent ROC curve, etc). The
values should be consistent with the values used to create \code{x}. The \code{NULL}
default will automatically use the first evaluation time used by \code{x}.}

\item{n}{An integer for the maximum number of top results/rows to return.}

\item{call}{The call to be shown in errors and warnings.}
}
\description{
\code{\link[tune:show_best]{tune::show_best()}} displays the top sub-models and their performance estimates.
}
\details{
For racing results (from the \pkg{finetune} package), it is best to only
report configurations that finished the race (i.e., were completely
resampled). Comparing performance metrics for configurations averaged with
different resamples is likely to lead to inappropriate results.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_race.R
\name{plot_race}
\alias{plot_race}
\title{Plot racing results}
\usage{
plot_race(x)
}
\arguments{
\item{x}{A object with class \code{tune_results}}
}
\value{
A ggplot object.
}
\description{
Plot the model results over stages of the racing results. A line is given
for each submodel that was tested.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/finetune-package.R
\docType{package}
\name{finetune-package}
\alias{finetune}
\alias{finetune-package}
\title{finetune: Additional Functions for Model Tuning}
\description{
\if{html}{\figure{logo.png}{options: style='float: right' alt='logo' width='120'}}

The ability to tune models is important. 'finetune' enhances the 'tune' package by providing more specialized methods for finding reasonable values of model tuning parameters. Two racing methods described by Kuhn (2014) \doi{10.48550/arXiv.1405.6974} are included. An iterative search method using generalized simulated annealing (Bohachevsky, Johnson and Stein, 1986) \doi{10.1080/00401706.1986.10488128} is also included.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/tidymodels/finetune}
  \item \url{https://finetune.tidymodels.org}
  \item Report bugs at \url{https://github.com/tidymodels/finetune/issues}
}

}
\author{
\strong{Maintainer}: Max Kuhn \email{max@posit.co} (\href{https://orcid.org/0000-0003-2402-136X}{ORCID})

Other contributors:
\itemize{
  \item Posit Software, PBC (\href{https://ror.org/03wc8by49}{ROR}) [copyright holder, funder]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/racing_helpers.R
\name{collect_predictions}
\alias{collect_predictions}
\alias{collect_predictions.tune_race}
\alias{collect_metrics.tune_race}
\title{Obtain and format results produced by racing functions}
\usage{
\method{collect_predictions}{tune_race}(
  x,
  ...,
  summarize = FALSE,
  parameters = NULL,
  all_configs = FALSE
)

\method{collect_metrics}{tune_race}(
  x,
  ...,
  summarize = TRUE,
  type = c("long", "wide"),
  all_configs = FALSE
)
}
\arguments{
\item{x}{The results of \code{\link[tune:tune_grid]{tune_grid()}}, \code{\link[tune:tune_bayes]{tune_bayes()}}, \code{\link[tune:fit_resamples]{fit_resamples()}},
or \code{\link[tune:last_fit]{last_fit()}}. For \code{\link[tune:collect_predictions]{collect_predictions()}}, the control option \code{save_pred = TRUE} should have been used.}

\item{...}{Not currently used.}

\item{summarize}{A logical; should metrics be summarized over resamples
(\code{TRUE}) or return the values for each individual resample. Note that, if \code{x}
is created by \code{\link[tune:last_fit]{last_fit()}}, \code{summarize} has no effect. For the other object
types, the method of summarizing predictions is detailed below.}

\item{parameters}{An optional tibble of tuning parameter values that can be
used to filter the predicted values before processing. This tibble should
only have columns for each tuning parameter identifier (e.g. \code{"my_param"}
if \code{tune("my_param")} was used).}

\item{all_configs}{A logical: should we return the complete set of model
configurations or just those that made it to the end of the race (the
default).}

\item{type}{One of \code{"long"} (the default) or \code{"wide"}. When \code{type = "long"},
output has columns \code{.metric} and one of \code{.estimate} or \code{mean}.
\code{.estimate}/\code{mean} gives the values for the \code{.metric}. When \code{type = "wide"},
each metric has its own column and the \code{n} and \code{std_err} columns are removed,
if they exist.}
}
\value{
A tibble. The column names depend on the results and the mode of the
model.
}
\description{
Obtain and format results produced by racing functions
}
\details{
For \code{\link[tune:collect_predictions]{tune::collect_metrics()}} and \code{\link[tune:collect_predictions]{tune::collect_predictions()}}, when unsummarized,
there are columns for each tuning parameter (using the \code{id} from \code{\link[hardhat:tune]{hardhat::tune()}},
if any).
\code{\link[tune:collect_predictions]{tune::collect_metrics()}} also has columns \code{.metric}, and \code{.estimator}.  When the
results are summarized, there are columns for \code{mean}, \code{n}, and \code{std_err}.
When not summarized, the additional columns for the resampling identifier(s)
and \code{.estimate}.

For \code{\link[tune:collect_predictions]{tune::collect_predictions()}}, there are additional columns for the resampling
identifier(s), columns for the predicted values (e.g., \code{.pred},
\code{.pred_class}, etc.), and a column for the outcome(s) using the original
column name(s) in the data.

\code{\link[tune:collect_predictions]{tune::collect_predictions()}} can summarize the various results over
replicate out-of-sample predictions. For example, when using the bootstrap,
each row in the original training set has multiple holdout predictions
(across assessment sets). To convert these results to a format where every
training set same has a single predicted value, the results are averaged
over replicate predictions.

For regression cases, the numeric predictions are simply averaged. For
classification models, the problem is more complex. When class probabilities
are used, these are averaged and then re-normalized to make sure that they
add to one. If hard class predictions also exist in the data, then these are
determined from the summarized probability estimates (so that they match).
If only hard class predictions are in the results, then the mode is used to
summarize.

For racing results, it is best to only
collect model configurations that finished the race (i.e., were completely
resampled). Comparing performance metrics for configurations averaged with
different resamples is likely to lead to inappropriate results.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/control_sim_anneal.R
\name{control_sim_anneal}
\alias{control_sim_anneal}
\title{Control aspects of the simulated annealing search process}
\usage{
control_sim_anneal(
  verbose = FALSE,
  verbose_iter = TRUE,
  no_improve = Inf,
  restart = 8L,
  radius = c(0.05, 0.15),
  flip = 3/4,
  cooling_coef = 0.02,
  extract = NULL,
  save_pred = FALSE,
  time_limit = NA,
  pkgs = NULL,
  save_workflow = FALSE,
  save_history = FALSE,
  event_level = "first",
  parallel_over = NULL,
  allow_par = TRUE,
  backend_options = NULL,
  workflow_size = 100
)
}
\arguments{
\item{verbose}{A logical for logging results (other than warnings and errors,
which are always shown) as they are generated during training in a single
R process. When using most parallel backends, this argument typically will
not result in any logging. If using a dark IDE theme, some logging messages
might be hard to see; try setting the \code{tidymodels.dark} option with
\code{options(tidymodels.dark = TRUE)} to print lighter colors.}

\item{verbose_iter}{A logical for logging results of the search
process. Defaults to FALSE. If using a dark IDE theme, some logging
messages might be hard to see; try setting the \code{tidymodels.dark} option
with \code{options(tidymodels.dark = TRUE)} to print lighter colors.}

\item{no_improve}{The integer cutoff for the number of iterations without
better results.}

\item{restart}{The number of iterations with no improvement before new tuning
parameter candidates are generated from the last, overall best conditions.}

\item{radius}{Two real numbers on \verb{(0, 1)} describing what a value "in the
neighborhood" of the current result should be. If all numeric parameters were
scaled to be on the \verb{[0, 1]} scale, these values set the min. and max.
of a radius of a circle used to generate new numeric parameter values.}

\item{flip}{A real number between \verb{[0, 1]} for the probability of changing
any non-numeric parameter values at each iteration.}

\item{cooling_coef}{A real, positive number to influence the cooling
schedule. Larger values decrease the probability of accepting a sub-optimal
parameter setting.}

\item{extract}{An optional function with at least one argument (or \code{NULL})
that can be used to retain arbitrary objects from the model fit object,
recipe, or other elements of the workflow.}

\item{save_pred}{A logical for whether the out-of-sample predictions should
be saved for each model \emph{evaluated}.}

\item{time_limit}{A number for the minimum number of \emph{minutes} (elapsed) that
the function should execute. The elapsed time is evaluated at internal
checkpoints and, if over time, the results at that time are returned (with
a warning). This means that the \code{time_limit} is not an exact limit, but a
minimum time limit.}

\item{pkgs}{An optional character string of R package names that should be
loaded (by namespace) during parallel processing.}

\item{save_workflow}{A logical for whether the workflow should be appended
to the output as an attribute.}

\item{save_history}{A logical to save the iteration details of the search.
These are saved to \code{tempdir()} named \code{sa_history.RData}. These results are
deleted when the R session ends. This option is only useful for teaching
purposes.}

\item{event_level}{A single string containing either \code{"first"} or \code{"second"}.
This argument is passed on to yardstick metric functions when any type
of class prediction is made, and specifies which level of the outcome
is considered the "event".}

\item{parallel_over}{A single string containing either \code{"resamples"} or
\code{"everything"} describing how to use parallel processing. Alternatively,
\code{NULL} is allowed, which chooses between \code{"resamples"} and \code{"everything"}
automatically.

If \code{"resamples"}, then tuning will be performed in parallel over resamples
alone. Within each resample, the preprocessor (i.e. recipe or formula) is
processed once, and is then reused across all models that need to be fit.

If \code{"everything"}, then tuning will be performed in parallel at two levels.
An outer parallel loop will iterate over resamples. Additionally, an
inner parallel loop will iterate over all unique combinations of
preprocessor and model tuning parameters for that specific resample. This
will result in the preprocessor being re-processed multiple times, but
can be faster if that processing is extremely fast.

If \code{NULL}, chooses \code{"resamples"} if there are more than one resample,
otherwise chooses \code{"everything"} to attempt to maximize core utilization.

Note that switching between \code{parallel_over} strategies is not guaranteed
to use the same random number generation schemes. However, re-tuning a
model using the same \code{parallel_over} strategy is guaranteed to be
reproducible between runs.}

\item{allow_par}{A logical to allow parallel processing (if a parallel
backend is registered).}

\item{backend_options}{An object of class \code{"tune_backend_options"} as created
by \code{tune::new_backend_options()}, used to pass arguments to specific tuning
backend. Defaults to \code{NULL} for default backend options.}

\item{workflow_size}{A non-negative number (in MB) that is used as a
threshold for a warning regarding the size of the workflow. Only used when
\code{save_workflow = TRUE}.}
}
\value{
An object of class \code{control_sim_anneal} that echos the argument values.
}
\description{
Control aspects of the simulated annealing search process
}
\examples{
control_sim_anneal()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tune_race_anova.R
\name{tune_race_anova}
\alias{tune_race_anova}
\alias{tune_race_anova.model_spec}
\alias{tune_race_anova.workflow}
\title{Efficient grid search via racing with ANOVA models}
\usage{
tune_race_anova(object, ...)

\method{tune_race_anova}{model_spec}(
  object,
  preprocessor,
  resamples,
  ...,
  param_info = NULL,
  grid = 10,
  metrics = NULL,
  eval_time = NULL,
  control = control_race()
)

\method{tune_race_anova}{workflow}(
  object,
  resamples,
  ...,
  param_info = NULL,
  grid = 10,
  metrics = NULL,
  eval_time = NULL,
  control = control_race()
)
}
\arguments{
\item{object}{A \code{parsnip} model specification or a \code{\link[workflows:workflow]{workflows::workflow()}}.}

\item{...}{Not currently used.}

\item{preprocessor}{A traditional model formula or a recipe created using
\code{\link[recipes:recipe]{recipes::recipe()}}. This is only required when \code{object} is not a workflow.}

\item{resamples}{An \code{rset()} object that has multiple resamples (i.e., is not
a validation set).}

\item{param_info}{A \code{\link[dials:parameters]{dials::parameters()}} object or \code{NULL}. If none is given,
a parameters set is derived from other arguments. Passing this argument can
be useful when parameter ranges need to be customized.}

\item{grid}{A data frame of tuning combinations or a positive integer. The
data frame should have columns for each parameter being tuned and rows for
tuning parameter candidates. An integer denotes the number of candidate
parameter sets to be created automatically.}

\item{metrics}{A \code{\link[yardstick:metric_set]{yardstick::metric_set()}} or \code{NULL}. The first metric in
metrics is the one that will be optimized.}

\item{eval_time}{A numeric vector of time points where dynamic event time
metrics should be computed (e.g. the time-dependent ROC curve, etc). The
values must be non-negative and should probably be no greater than the
largest event time in the training set (See Details below).}

\item{control}{An object used to modify the tuning process. See
\code{\link[=control_race]{control_race()}} for more details.}
}
\value{
An object with primary class \code{tune_race} in the same standard format
as objects produced by \code{\link[tune:tune_grid]{tune::tune_grid()}}.
}
\description{
\code{\link[=tune_race_anova]{tune_race_anova()}} computes a set of performance metrics (e.g. accuracy or RMSE)
for a pre-defined set of tuning parameters that correspond to a model or
recipe across one or more resamples of the data. After an initial number of
resamples have been evaluated, the process eliminates tuning parameter
combinations that are unlikely to be the best results using a repeated
measure ANOVA model.
}
\details{
The technical details of this method are described in Kuhn (2014).

Racing methods are efficient approaches to grid search. Initially, the
function evaluates all tuning parameters on a small initial set of
resamples. The \code{burn_in} argument of \code{\link[=control_race]{control_race()}} sets the number of
initial resamples.

The performance statistics from these resamples are analyzed to determine
which tuning parameters are \emph{not} statistically different from the current
best setting. If a parameter is statistically different, it is excluded from
further resampling.

The next resample is used with the remaining parameter combinations and the
statistical analysis is updated. More candidate parameters may be excluded
with each new resample that is processed.

This function determines statistical significance using a repeated measures ANOVA
model where the performance statistic (e.g., RMSE, accuracy, etc.) is the
outcome data and the random effect is due to resamples. The
\code{\link[=control_race]{control_race()}} function contains are parameter for the significance cutoff
applied to the ANOVA results as well as other relevant arguments.

There is benefit to using racing methods in conjunction with parallel
processing. The following section shows a benchmark of results for one
dataset and model.
\subsection{Censored regression models}{

With dynamic performance metrics (e.g. Brier or ROC curves), performance is
calculated for every value of \code{eval_time} but the \emph{first} evaluation time
given by the user (e.g., \code{eval_time[1]}) is analyzed during racing.

Also, values of \code{eval_time} should be less than the largest observed event
time in the training data. For many non-parametric models, the results beyond
the largest time corresponding to an event are constant (or \code{NA}).
}

\subsection{Benchmarking results}{

To demonstrate, we use a SVM model with the \code{kernlab} package.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{library(kernlab)
library(tidymodels)
library(finetune)
library(doParallel)

## -----------------------------------------------------------------------------

data(cells, package = "modeldata")
cells <- cells |> select(-case)

## -----------------------------------------------------------------------------

set.seed(6376)
rs <- bootstraps(cells, times = 25)
}\if{html}{\out{</div>}}

We’ll only tune the model parameters (i.e., not recipe tuning):

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------

svm_spec <-
  svm_rbf(cost = tune(), rbf_sigma = tune()) |>
  set_engine("kernlab") |>
  set_mode("classification")

svm_rec <-
  recipe(class ~ ., data = cells) |>
  step_YeoJohnson(all_predictors()) |>
  step_normalize(all_predictors())

svm_wflow <-
  workflow() |>
  add_model(svm_spec) |>
  add_recipe(svm_rec)

set.seed(1)
svm_grid <-
  svm_spec |>
  parameters() |>
  grid_latin_hypercube(size = 25)
}\if{html}{\out{</div>}}

We’ll get the times for grid search and ANOVA racing with and without
parallel processing:

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------
## Regular grid search

system.time(\{
  set.seed(2)
  svm_wflow |> tune_grid(resamples = rs, grid = svm_grid)
\})
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{##    user  system elapsed 
## 741.660  19.654 761.357 
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------
## With racing

system.time(\{
  set.seed(2)
  svm_wflow |> tune_race_anova(resamples = rs, grid = svm_grid)
\})
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{##    user  system elapsed 
## 133.143   3.675 136.822 
}\if{html}{\out{</div>}}

Speed-up of 5.56-fold for racing.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------
## Parallel processing setup

cores <- parallel::detectCores(logical = FALSE)
cores
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{## [1] 10
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode r">}}\preformatted{cl <- makePSOCKcluster(cores)
registerDoParallel(cl)
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------
## Parallel grid search

system.time(\{
  set.seed(2)
  svm_wflow |> tune_grid(resamples = rs, grid = svm_grid)
\})
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{##  user  system elapsed 
## 1.112   0.190 126.650 
}\if{html}{\out{</div>}}

Parallel processing with grid search was 6.01-fold faster than
sequential grid search.

\if{html}{\out{<div class="sourceCode r">}}\preformatted{## -----------------------------------------------------------------------------
## Parallel racing

system.time(\{
  set.seed(2)
  svm_wflow |> tune_race_anova(resamples = rs, grid = svm_grid)
\})
}\if{html}{\out{</div>}}

\if{html}{\out{<div class="sourceCode">}}\preformatted{##  user  system elapsed 
## 1.908   0.261  21.442 
}\if{html}{\out{</div>}}

Parallel processing with racing was 35.51-fold faster than sequential
grid search.

There is a compounding effect of racing and parallel processing but its
magnitude depends on the type of model, number of resamples, number of
tuning parameters, and so on.
}
}
\examples{
\donttest{
library(parsnip)
library(rsample)
library(dials)

## -----------------------------------------------------------------------------

if (rlang::is_installed(c("discrim", "lme4", "modeldata"))) {
  library(discrim)
  data(two_class_dat, package = "modeldata")

  set.seed(6376)
  rs <- bootstraps(two_class_dat, times = 10)

  ## -----------------------------------------------------------------------------

  # optimize an regularized discriminant analysis model
  rda_spec <-
    discrim_regularized(frac_common_cov = tune(), frac_identity = tune()) |>
    set_engine("klaR")

  ## -----------------------------------------------------------------------------

  ctrl <- control_race(verbose_elim = TRUE)
  set.seed(11)
  grid_anova <-
    rda_spec |>
    tune_race_anova(Class ~ ., resamples = rs, grid = 10, control = ctrl)

  # Shows only the fully resampled parameters
  show_best(grid_anova, metric = "roc_auc", n = 2)

  plot_race(grid_anova)
}
}
}
\references{
Kuhn, M 2014. "Futility Analysis in the Cross-Validation of Machine Learning
Models." \url{https://arxiv.org/abs/1405.6974}.
}
\seealso{
\code{\link[tune:tune_grid]{tune::tune_grid()}}, \code{\link[=control_race]{control_race()}}, \code{\link[=tune_race_win_loss]{tune_race_win_loss()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tune_sim_anneal.R
\name{tune_sim_anneal}
\alias{tune_sim_anneal}
\alias{tune_sim_anneal.model_spec}
\alias{tune_sim_anneal.workflow}
\title{Optimization of model parameters via simulated annealing}
\usage{
tune_sim_anneal(object, ...)

\method{tune_sim_anneal}{model_spec}(
  object,
  preprocessor,
  resamples,
  ...,
  iter = 10,
  param_info = NULL,
  metrics = NULL,
  eval_time = NULL,
  initial = 1,
  control = control_sim_anneal()
)

\method{tune_sim_anneal}{workflow}(
  object,
  resamples,
  ...,
  iter = 10,
  param_info = NULL,
  metrics = NULL,
  eval_time = NULL,
  initial = 1,
  control = control_sim_anneal()
)
}
\arguments{
\item{object}{A \code{parsnip} model specification or a \code{\link[workflows:workflow]{workflows::workflow()}}.}

\item{...}{Not currently used.}

\item{preprocessor}{A traditional model formula or a recipe created using
\code{\link[recipes:recipe]{recipes::recipe()}}. This is only required when \code{object} is not a workflow.}

\item{resamples}{An \code{rset()} object.}

\item{iter}{The maximum number of search iterations.}

\item{param_info}{A \code{\link[dials:parameters]{dials::parameters()}} object or \code{NULL}. If none is given,
a parameter set is derived from other arguments. Passing this argument can
be useful when parameter ranges need to be customized.}

\item{metrics}{A \code{\link[yardstick:metric_set]{yardstick::metric_set()}} object containing information on how
models will be evaluated for performance. The first metric in \code{metrics} is the
one that will be optimized.}

\item{eval_time}{A numeric vector of time points where dynamic event time
metrics should be computed (e.g. the time-dependent ROC curve, etc). The
values must be non-negative and should probably be no greater than the
largest event time in the training set (See Details below).}

\item{initial}{An initial set of results in a tidy format (as would the result
of \code{\link[tune:tune_grid]{tune::tune_grid()}}, \code{\link[tune:tune_bayes]{tune::tune_bayes()}}, \code{\link[=tune_race_win_loss]{tune_race_win_loss()}}, or
\code{\link[=tune_race_anova]{tune_race_anova()}}) or a positive integer. If the initial object was a
sequential search method, the simulated annealing iterations start after the
last iteration of the initial results.}

\item{control}{The results of \code{\link[=control_sim_anneal]{control_sim_anneal()}}.}
}
\value{
A tibble of results that mirror those generated by \code{\link[tune:tune_grid]{tune::tune_grid()}}.
However, these results contain an \code{.iter} column and replicate the \code{rset}
object multiple times over iterations (at limited additional memory costs).
}
\description{
\code{\link[=tune_sim_anneal]{tune_sim_anneal()}} uses an iterative search procedure to generate new
candidate tuning parameter combinations based on previous results. It uses
the generalized simulated annealing method of Bohachevsky, Johnson, and
Stein (1986).
}
\details{
Simulated annealing is a global optimization method. For model tuning, it
can be used to iteratively search the parameter space for optimal tuning
parameter combinations. At each iteration, a new parameter combination is
created by perturbing the current parameters in some small way so that they
are within a small neighborhood. This new parameter combination is used to
fit a model and that model's performance is measured using resampling (or a
simple validation set).

If the new settings have better results than the current settings, they are
accepted and the process continues.

If the new settings has worse performance, a probability threshold is
computed for accepting these sub-optimal values. The probability is a
function of \emph{how} sub-optimal the results are as well as how many iterations
have elapsed. This is referred to as the "cooling schedule" for the
algorithm. If the sub-optimal results are accepted, the next iterations
settings are based on these inferior results. Otherwise, new parameter
values are generated from the previous iteration's settings.

This process continues for a pre-defined number of iterations and the
overall best settings are recommended for use. The \code{\link[=control_sim_anneal]{control_sim_anneal()}}
function can specify the number of iterations without improvement for early
stopping. Also, that function can be used to specify a \emph{restart} threshold;
if no globally best results have not be discovered within a certain number
if iterations, the process can restart using the last known settings that
globally best.
\subsection{Creating new settings}{

For each numeric parameter, the range of possible values is known as well
as any transformations. The current values are transformed and scaled to
have values between zero and one (based on the possible range of values). A
candidate set of values that are on a sphere with random radii between
\code{rmin} and \code{rmax} are generated. Infeasible values are removed and one value
is chosen at random. This value is back transformed to the original units
and scale and are used as the new settings. The argument \code{radius} of
\code{\link[=control_sim_anneal]{control_sim_anneal()}} controls the range neighborhood sizes.

For categorical and integer parameters, each is changes with a pre-defined
probability. The \code{flip} argument of \code{\link[=control_sim_anneal]{control_sim_anneal()}} can be used to
specify this probability. For integer parameters, a nearby integer value is
used.

Simulated annealing search may not be the preferred method when many of the
parameters are non-numeric or integers with few unique values. In these
cases, it is likely that the same candidate set may be tested more than
once.
}

\subsection{Cooling schedule}{

To determine the probability of accepting a new value, the percent
difference in performance is calculated. If the performance metric is to be
maximized, this would be \code{d = (new-old)/old*100}. The probability is
calculated as \code{p = exp(d * coef * iter)} were \code{coef} is a user-defined
constant that can be used to increase or decrease the probabilities.

The \code{cooling_coef} of \code{\link[=control_sim_anneal]{control_sim_anneal()}} can be used for this purpose.
}

\subsection{Termination criterion}{

The restart counter is reset when a new global best results is found.

The termination counter resets when a new global best is located or when a
suboptimal result is improved.
}

\subsection{Parallelism}{

The \code{tune} and \code{finetune} packages currently parallelize over resamples.
Specifying a parallel back-end will improve the generation of the initial
set of sub-models (if any). Each iteration of the search are also run in
parallel if a parallel backend is registered.
}

\subsection{Censored regression models}{

With dynamic performance metrics (e.g. Brier or ROC curves), performance is
calculated for every value of \code{eval_time} but the \emph{first} evaluation time
given by the user (e.g., \code{eval_time[1]}) is used to guide the optimization.

Also, values of \code{eval_time} should be less than the largest observed event
time in the training data. For many non-parametric models, the results beyond
the largest time corresponding to an event are constant (or \code{NA}).
}
}
\examples{
\donttest{
library(finetune)
library(rpart)
library(dplyr)
library(tune)
library(rsample)
library(parsnip)
library(workflows)
library(ggplot2)

## -----------------------------------------------------------------------------
if (rlang::is_installed("modeldata")) {
  data(two_class_dat, package = "modeldata")

  set.seed(5046)
  bt <- bootstraps(two_class_dat, times = 5)

  ## -----------------------------------------------------------------------------

  cart_mod <-
    decision_tree(cost_complexity = tune(), min_n = tune()) |>
    set_engine("rpart") |>
    set_mode("classification")

  ## -----------------------------------------------------------------------------

  # For reproducibility, set the seed before running.
  set.seed(10)
  sa_search <-
    cart_mod |>
    tune_sim_anneal(Class ~ ., resamples = bt, iter = 10)

  autoplot(sa_search, metric = "roc_auc", type = "parameters") +
    theme_bw()

  ## -----------------------------------------------------------------------------
  # More iterations. `initial` can be any other tune_* object or an integer
  # (for new values).

  set.seed(11)
  more_search <-
    cart_mod |>
    tune_sim_anneal(Class ~ ., resamples = bt, iter = 10, initial = sa_search)

  autoplot(more_search, metric = "roc_auc", type = "performance") +
    theme_bw()
}
}
}
\references{
Bohachevsky, Johnson, and Stein (1986) "Generalized Simulated Annealing for
Function Optimization", \emph{Technometrics}, 28:3, 209-217
}
\seealso{
\code{\link[tune:tune_grid]{tune::tune_grid()}}, \code{\link[=control_sim_anneal]{control_sim_anneal()}}, \code{\link[yardstick:metric_set]{yardstick::metric_set()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tune_race_win_loss.R
\name{tune_race_win_loss}
\alias{tune_race_win_loss}
\alias{tune_race_win_loss.model_spec}
\alias{tune_race_win_loss.workflow}
\title{Efficient grid search via racing with win/loss statistics}
\usage{
tune_race_win_loss(object, ...)

\method{tune_race_win_loss}{model_spec}(
  object,
  preprocessor,
  resamples,
  ...,
  param_info = NULL,
  grid = 10,
  metrics = NULL,
  eval_time = NULL,
  control = control_race()
)

\method{tune_race_win_loss}{workflow}(
  object,
  resamples,
  ...,
  param_info = NULL,
  grid = 10,
  metrics = NULL,
  eval_time = NULL,
  control = control_race()
)
}
\arguments{
\item{object}{A \code{parsnip} model specification or a \code{\link[workflows:workflow]{workflows::workflow()}}.}

\item{...}{Not currently used.}

\item{preprocessor}{A traditional model formula or a recipe created using
\code{\link[recipes:recipe]{recipes::recipe()}}. This is only required when \code{object} is not a workflow.}

\item{resamples}{An \code{rset()} object that has multiple resamples (i.e., is not
a validation set).}

\item{param_info}{A \code{\link[dials:parameters]{dials::parameters()}} object or \code{NULL}. If none is given,
a parameters set is derived from other arguments. Passing this argument can
be useful when parameter ranges need to be customized.}

\item{grid}{A data frame of tuning combinations or a positive integer. The
data frame should have columns for each parameter being tuned and rows for
tuning parameter candidates. An integer denotes the number of candidate
parameter sets to be created automatically.}

\item{metrics}{A \code{\link[yardstick:metric_set]{yardstick::metric_set()}} or \code{NULL}. The first metric in
metrics is the one that will be optimized.}

\item{eval_time}{A numeric vector of time points where dynamic event time
metrics should be computed (e.g. the time-dependent ROC curve, etc). The
values must be non-negative and should probably be no greater than the
largest event time in the training set (See Details below).}

\item{control}{An object used to modify the tuning process. See
\code{\link[=control_race]{control_race()}} for more details.}
}
\value{
An object with primary class \code{tune_race} in the same standard format
as objects produced by \code{\link[tune:tune_grid]{tune::tune_grid()}}.
}
\description{
\code{\link[=tune_race_win_loss]{tune_race_win_loss()}} computes a set of performance metrics (e.g. accuracy or RMSE)
for a pre-defined set of tuning parameters that correspond to a model or
recipe across one or more resamples of the data. After an initial number of
resamples have been evaluated, the process eliminates tuning parameter
combinations that are unlikely to be the best results using a statistical
model. For each pairwise combinations of tuning parameters, win/loss
statistics are calculated and a logistic regression model is used to measure
how likely each combination is to win overall.
}
\details{
The technical details of this method are described in Kuhn (2014).

Racing methods are efficient approaches to grid search. Initially, the
function evaluates all tuning parameters on a small initial set of
resamples. The \code{burn_in} argument of \code{\link[=control_race]{control_race()}} sets the number of
initial resamples.

The performance statistics from the current set of resamples are converted
to win/loss/tie results. For example, for two parameters (\code{j} and \code{k}) in a
classification model that have each been resampled three times:

\preformatted{
            |  area under the ROC curve |
            -----------------------------
   resample | parameter j | parameter k | winner
   ---------------------------------------------
       1    |    0.81     |     0.92    |   k
       2    |    0.95     |     0.94    |   j
       3    |    0.79     |     0.81    |   k
   ---------------------------------------------
}

After the third resample, parameter \code{k} has a 2:1 win/loss ratio versus \code{j}.
Parameters with equal results are treated as a half-win for each setting.
These statistics are determined for all pairwise combinations of the
parameters and a Bradley-Terry model is used to model these win/loss/tie
statistics. This model can compute the ability of a parameter combination to
win overall. A confidence interval for the winning ability is computed and
any settings whose interval includes zero are retained for future resamples
(since it is not statistically different form the best results).

The next resample is used with the remaining parameter combinations and the
statistical analysis is updated. More candidate parameters may be excluded
with each new resample that is processed.

The \code{\link[=control_race]{control_race()}} function contains parameters for the significance cutoff
applied to the Bradley-Terry model results as well as other relevant arguments.
The first metric in the \code{metrics} argument is the one that will be optimized.
\subsection{Censored regression models}{

With dynamic performance metrics (e.g. Brier or ROC curves), performance is
calculated for every value of \code{eval_time} but the \emph{first} evaluation time
given by the user (e.g., \code{eval_time[1]}) is analyzed during racing.

Also, values of \code{eval_time} should be less than the largest observed event
time in the training data. For many non-parametric models, the results beyond
the largest time corresponding to an event are constant (or \code{NA}).
}
}
\examples{
\donttest{
library(parsnip)
library(rsample)
library(dials)

## -----------------------------------------------------------------------------

if (rlang::is_installed(c("discrim", "modeldata"))) {
  library(discrim)
  data(two_class_dat, package = "modeldata")

  set.seed(6376)
  rs <- bootstraps(two_class_dat, times = 10)

  ## -----------------------------------------------------------------------------

  # optimize an regularized discriminant analysis model
  rda_spec <-
    discrim_regularized(frac_common_cov = tune(), frac_identity = tune()) |>
    set_engine("klaR")

  ## -----------------------------------------------------------------------------

  ctrl <- control_race(verbose_elim = TRUE)

  set.seed(11)
  grid_wl <-
    rda_spec |>
    tune_race_win_loss(Class ~ ., resamples = rs, grid = 10, control = ctrl)

  # Shows only the fully resampled parameters
  show_best(grid_wl, metric = "roc_auc")

  plot_race(grid_wl)
}
}
}
\references{
Kuhn, M 2014. "Futility Analysis in the Cross-Validation of Machine Learning
Models." \url{https://arxiv.org/abs/1405.6974}.
}
\seealso{
\code{\link[tune:tune_grid]{tune::tune_grid()}}, \code{\link[=control_race]{control_race()}}, \code{\link[=tune_race_anova]{tune_race_anova()}}
}
